#include <revolution/external.h>
#include <windows.h>
#include <gl/gl.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

// External functions and commands are only distinguised by their entry at the bottom
// Functions are called with args in parenthesis () and they return a value
// commands do not return a value and they do not nedd perenthesis
#define LC_ENTRY(x) void x(char *p_arguments[], int p_argument_count, char **r_result, Bool *r_pass, Bool *r_err)

// define what happens on error or no error
#define LC_ERROR(x) { *r_err = True; *r_pass = False; *r_result = strdup(x); return; }
#define LC_NO_ERROR {*r_err = False; *r_pass = False;}

// simple error checking on arg count passed from LC
#define LC_ARG_COUNT(argn) { if(p_argument_count < argn) { 	LC_ERROR("Not Enough Arguments"); }}

//Return Values to LC
// should be some kind of error checking in here...
#define LC_RETURN_VOID { *r_err = False; *r_pass = False; *r_result = strdup(""); return; }
#define LC_RETURN_POINTER { if(!result) LC_ERROR("Invalid Pointer!") else { *r_result = (char*)malloc( 20 ); _snprintf(*r_result, 20, "%p", result); LC_NO_ERROR; return;} }
#define LC_RETURN_INT { *r_result = (char*) malloc(20); _snprintf(*r_result, 20, "%d", result); LC_NO_ERROR; return; }
#define LC_RETURN_UINT { *r_result = (char*) malloc(20); _snprintf(*r_result, 20, "%u", result); LC_NO_ERROR; return; }
#define LC_RETURN_STRING { *r_result = strdup(result); LC_NO_ERROR; return; }
#define LC_RETURN_FLOAT { *r_result = (char*) malloc(20); _snprintf(*r_result, 20, "%f", result); LC_NO_ERROR; return; }

// read arguments
#define LC_READARG(var, number, tmpl) if(!sscanf(p_arguments[ number ], tmpl, & var)) { 	LC_ERROR("Failed to read argument"); }

// globals for openb3d.dll handle, LC window handle, device context and rendering context
HMODULE dll;
HWND hWnd;
HDC hDC;
HGLRC hRC;

// Declarations for function pointers for functions i openb3d.dll that we want to access
// Should really go in a header file but I canna be arsed at the moment...
typedef void ( __cdecl *BUFFERTOTEX ) (char* tex , unsigned char* , int frame );
typedef void ( __cdecl *BACKBUFFERTOTEX ) (char* tex , int frame );
typedef void ( __cdecl *TEXTOBUFFER ) (char* tex , unsigned char* , int frame );
typedef void ( __cdecl *MESHCULLRADIUS ) (char* ent , float radius );
typedef int ( __cdecl *ADDANIMSEQ ) (char* ent , int length );
typedef void ( __cdecl *ADDMESH ) (char* mesh1 , char* mesh2 );
typedef int ( __cdecl *ADDTRIANGLE ) (char* surf , int v0 , int v1 , int v2 );
typedef int ( __cdecl *ADDVERTEX ) (char* surf , float x , float y , float z , float u , float v , float w );
typedef void ( __cdecl *AMBIENTLIGHT ) (float r , float g , float b );
typedef void ( __cdecl *ANTIALIAS ) (int samples );
typedef void ( __cdecl *ANIMATE ) (char* ent , int mode , float speed , int seq , int trans );
typedef int ( __cdecl *ANIMATING ) (char* ent );
typedef int ( __cdecl *ANIMLENGTH ) (char* ent );
typedef int ( __cdecl *ANIMSEQ ) (char* ent );
typedef float ( __cdecl *ANIMTIME ) (char* ent );
typedef void ( __cdecl *BRUSHALPHA ) (char* brush , float a );
typedef void ( __cdecl *BRUSHBLEND ) (char* brush , int blend );
typedef void ( __cdecl *BRUSHCOLOR ) (char* brush , float r , float g , float b );
typedef void ( __cdecl *BRUSHFX ) (char* brush , int fx );
typedef void ( __cdecl *BRUSHSHININESS ) (char* brush , float s );
typedef void ( __cdecl *BRUSHTEXTURE ) (char* brush , char* tex , int frame , int index );
typedef void ( __cdecl *CAMERACLSCOLOR ) (char* cam , float r , float g , float b );
typedef void ( __cdecl *CAMERACLSMODE ) (char* cam , int cls_depth , int cls_zbuffer );
typedef void ( __cdecl *CAMERAFOGCOLOR ) (char* cam , float r , float g , float b );
typedef void ( __cdecl *CAMERAFOGMODE ) (char* cam , int mode );
typedef void ( __cdecl *CAMERAFOGRANGE ) (char* cam , float nnear , float nfar );
typedef char* ( __cdecl *CAMERAPICK ) (char* cam , float x , float y );
typedef void ( __cdecl *CAMERAPROJECT ) (char* cam , float x , float y , float z );
typedef void ( __cdecl *CAMERAPROJMODE ) (char* cam , int mode );
typedef void ( __cdecl *CAMERARANGE ) (char* cam , float nnear , float nfar );
typedef void ( __cdecl *CAMERAVIEWPORT ) (char* cam , int x , int y , int width , int height );
typedef void ( __cdecl *CAMERAZOOM ) (char* cam , float zoom );
typedef void ( __cdecl *CLEARCOLLISIONS ) (void    );
typedef void ( __cdecl *CLEARSURFACE ) (char* surf , bool clear_verts , bool clear_tris );
typedef void ( __cdecl *CLEARTEXTUREFILTERS ) (void    );
typedef void ( __cdecl *CLEARWORLD ) (bool entities , bool brushes , bool textures );
typedef char* ( __cdecl *COLLISIONENTITY ) (char* ent , int index );
typedef void ( __cdecl *COLLISIONS ) (int src_no , int dest_no , int method_no , int response_no );
typedef float ( __cdecl *COLLISIONNX ) (char* ent , int index );
typedef float ( __cdecl *COLLISIONNY ) (char* ent , int index );
typedef float ( __cdecl *COLLISIONNZ ) (char* ent , int index );
typedef char* ( __cdecl *COLLISIONSURFACE ) (char* ent , int index );
typedef float ( __cdecl *COLLISIONTIME ) (char* ent , int index );
typedef int ( __cdecl *COLLISIONTRIANGLE ) (char* ent , int index );
typedef float ( __cdecl *COLLISIONX ) (char* ent , int index );
typedef float ( __cdecl *COLLISIONY ) (char* ent , int index );
typedef float ( __cdecl *COLLISIONZ ) (char* ent , int index );
typedef int ( __cdecl *COUNTCHILDREN ) (char* ent );
typedef int ( __cdecl *COUNTCOLLISIONS ) (char* ent );
typedef char* ( __cdecl *COPYENTITY ) (char* ent , char* parent );
typedef char* ( __cdecl *COPYMESH ) (char* mesh , char* parent );
typedef int ( __cdecl *COUNTSURFACES ) (char* mesh );
typedef int ( __cdecl *COUNTTRIANGLES ) (char* surf );
typedef int ( __cdecl *COUNTVERTICES ) (char* surf );
typedef char* ( __cdecl *CREATEBRUSH ) (float r , float g , float b );
typedef char* ( __cdecl *CREATECAMERA ) (char* parent );
typedef char* ( __cdecl *CREATECONE ) (int segments , bool solid , char* parent );
typedef char* ( __cdecl *CREATECYLINDER ) (int segments , bool solid , char* parent );
typedef char* ( __cdecl *CREATECUBE ) (char* parent );
typedef char* ( __cdecl *CREATEMESH ) (char* parent );
typedef char* ( __cdecl *CREATELIGHT ) (int light_type , char* parent );
typedef char* ( __cdecl *CREATEPIVOT ) (char* parent );
typedef char* ( __cdecl *CREATEPLANE ) (int divisions , char* parent );
typedef char* ( __cdecl *CREATESHADOW ) (char* parent , int Static );
typedef char* ( __cdecl *CREATESPHERE ) (int segments , char* parent );
typedef char* ( __cdecl *CREATESPRITE ) (char* parent );
typedef char* ( __cdecl *CREATESURFACE ) (char* mesh , char* brush );
typedef char* ( __cdecl *CREATESTENCIL ) ( );
typedef char* ( __cdecl *CREATETERRAIN ) (int size , char* parent );
typedef char* ( __cdecl *CREATETEXTURE ) (int width , int height , int flags , int frames );
typedef char* ( __cdecl *CREATEVOXELSPRITE ) (int slices , char* parent );
typedef float ( __cdecl *DELTAPITCH ) (char* ent1 , char* ent2 );
typedef float ( __cdecl *DELTAYAW ) (char* ent1 , char* ent2 );
typedef void ( __cdecl *ENTITYALPHA ) (char* ent , float alpha );
typedef void ( __cdecl *ENTITYAUTOFADE ) (char* ent , float near , float far );
typedef void ( __cdecl *ENTITYBLEND ) (char* ent , int blend );
typedef void ( __cdecl *ENTITYBOX ) (char* ent , float x , float y , float z , float w , float h , float d );
typedef char* ( __cdecl *ENTITYCOLLIDED ) (char* ent , int type_no );
typedef void ( __cdecl *ENTITYCOLOR ) (char* ent , float red , float green , float blue );
typedef float ( __cdecl *ENTITYDISTANCE ) (char* ent1 , char* ent2 );
typedef void ( __cdecl *ENTITYFX ) (char* ent , int fx );
typedef int ( __cdecl *ENTITYINVIEW ) (char* ent , char* cam );
typedef void ( __cdecl *ENTITYORDER ) (char* ent , int order );
typedef void ( __cdecl *ENTITYPARENT ) (char* ent , char* parent_ent , bool glob );
typedef char* ( __cdecl *ENTITYPICK ) (char* ent , float range );
typedef void ( __cdecl *ENTITYPICKMODE ) (char* ent , int pick_mode , bool obscurer );
typedef float ( __cdecl *ENTITYPITCH ) (char* ent , bool glob );
typedef void ( __cdecl *ENTITYRADIUS ) (char* ent , float radius_x , float radius_y );
typedef float ( __cdecl *ENTITYROLL ) (char* ent , bool glob );
typedef void ( __cdecl *ENTITYSHININESS ) (char* ent , float shine );
typedef void ( __cdecl *ENTITYTEXTURE ) (char* ent , char* tex , int frame , int index );
typedef void ( __cdecl *ENTITYTYPE ) (char* ent , int type_no , bool recursive );
typedef int ( __cdecl *ENTITYVISIBLE ) (char* src_ent , char* dest_ent );
typedef float ( __cdecl *ENTITYX ) (char* ent , bool glob );
typedef float ( __cdecl *ENTITYY ) (char* ent , bool glob );
typedef float ( __cdecl *ENTITYYAW ) (char* ent , bool glob );
typedef float ( __cdecl *ENTITYZ ) (char* ent , bool glob );
typedef int ( __cdecl *EXTRACTANIMSEQ ) (char* ent , int first_frame , int last_frame , int seq );
typedef char* ( __cdecl *FINDCHILD ) (char* ent , char* child_name );
typedef char* ( __cdecl *FINDSURFACE ) (char* mesh , char* brush );
typedef void ( __cdecl *FITMESH ) (char* mesh , float x , float y , float z , float width , float height , float depth , bool uniform );
typedef void ( __cdecl *FLIPMESH ) (char* mesh );
typedef void ( __cdecl *FREEBRUSH ) (char* brush );
typedef void ( __cdecl *FREEENTITY ) (char* ent );
typedef void ( __cdecl *FREESHADOW ) (char* shad );
typedef void ( __cdecl *FREETEXTURE ) (char* tex );
typedef char* ( __cdecl *GETBRUSHTEXTURE ) (char* brush , int index );
typedef char* ( __cdecl *GETCHILD ) (char* ent , int child_no );
typedef char* ( __cdecl *GETENTITYBRUSH ) (char* ent );
typedef int ( __cdecl *GETENTITYTYPE ) (char* ent );
typedef float ( __cdecl *GETMATELEMENT ) (char* ent , int row , int col );
typedef char* ( __cdecl *GETPARENTENTITY ) (char* ent );
typedef char* ( __cdecl *GETSURFACE ) (char* mesh , int surf_no );
typedef char* ( __cdecl *GETSURFACEBRUSH ) (char* surf );
typedef void ( __cdecl *GRAPHICS3D ) (int width , int height , int depth , int mode , int rate );
typedef void ( __cdecl *GRAPHICSRESIZE ) (int width , int height );
typedef void ( __cdecl *HANDLESPRITE ) (char* sprite , float h_x , float h_y );
typedef void ( __cdecl *HIDEENTITY ) (char* ent );
typedef void ( __cdecl *LIGHTCOLOR ) (char* light , float red , float green , float blue );
typedef void ( __cdecl *LIGHTCONEANGLES ) (char* light , float inner_ang , float outer_ang );
typedef void ( __cdecl *LIGHTRANGE ) (char* light , float range );
typedef char* ( __cdecl *LINEPICK ) (float x , float y , float z , float dx , float dy , float dz , float radius );
typedef char* ( __cdecl *LOADANIMMESH ) (char* file , char* parent );
typedef char* ( __cdecl *LOADANIMTEXTURE ) (char* file , int flags , int frame_width , int frame_height , int first_frame , int frame_count );
typedef char* ( __cdecl *LOADBRUSH ) (char *file , int flags , float u_scale , float v_scale );
typedef char* ( __cdecl *LOADMESH ) (char* file , char* parent );
typedef char* ( __cdecl *LOADTERRAIN ) (char* file , char* parent );
typedef char* ( __cdecl *LOADTEXTURE ) (char* file , int flags );
typedef char* ( __cdecl *LOADSPRITE ) (char* tex_file , int tex_flag , char* parent );
typedef char* ( __cdecl *MESHCSG ) (char* m1 , char* m2 , int method );
typedef float ( __cdecl *MESHDEPTH ) (char* mesh );
typedef int ( __cdecl *MESHESINTERSECT ) (char* mesh1 , char* mesh2 );
typedef float ( __cdecl *MESHHEIGHT ) (char* mesh );
typedef float ( __cdecl *MESHWIDTH ) (char* mesh );
typedef void ( __cdecl *MODIFYTERRAIN ) (char* terr , int x , int z , float new_height );
typedef void ( __cdecl *MOVEENTITY ) (char* ent , float x , float y , float z );
typedef void ( __cdecl *NAMEENTITY ) (char* ent , char* name );
typedef void ( __cdecl *PAINTENTITY ) (char* ent , char* brush );
typedef void ( __cdecl *PAINTMESH ) (char* mesh , char* brush );
typedef void ( __cdecl *PAINTSURFACE ) (char* surf , char* brush );
typedef char* ( __cdecl *PICKEDENTITY ) (void   );
typedef float ( __cdecl *PICKEDNX ) (void   );
typedef float ( __cdecl *PICKEDNY ) (void   );
typedef float ( __cdecl *PICKEDNZ ) (void   );
typedef char* ( __cdecl *PICKEDSURFACE ) ( );
typedef float ( __cdecl *PICKEDTIME ) (void   );
typedef int ( __cdecl *PICKEDTRIANGLE ) (void   );
typedef float ( __cdecl *PICKEDX ) (void   );
typedef float ( __cdecl *PICKEDY ) (void   );
typedef float ( __cdecl *PICKEDZ ) (void   );
typedef void ( __cdecl *POINTENTITY ) (char* ent , char* target_ent , float roll );
typedef void ( __cdecl *POSITIONENTITY ) (char* ent , float x , float y , float z , bool glob );
typedef void ( __cdecl *POSITIONMESH ) (char* mesh , float px , float py , float pz );
typedef void ( __cdecl *POSITIONTEXTURE ) (char* tex , float u_pos , float v_pos );
typedef float ( __cdecl *PROJECTEDX ) (void   );
typedef float ( __cdecl *PROJECTEDY ) (void   );
typedef float ( __cdecl *PROJECTEDZ ) (void   );
typedef void ( __cdecl *RENDERWORLD ) (void   );
typedef char* ( __cdecl *REPEATMESH ) (char* mesh , char* parent );
typedef void ( __cdecl *RESETENTITY ) (char* ent );
typedef void ( __cdecl *ROTATEENTITY ) (char* ent , float x , float y , float z , bool glob );
typedef void ( __cdecl *ROTATEMESH ) (char* mesh , float pitch , float yaw , float roll );
typedef void ( __cdecl *ROTATESPRITE ) (char* sprite , float ang );
typedef void ( __cdecl *ROTATETEXTURE ) (char* tex , float ang );
typedef void ( __cdecl *SCALEENTITY ) (char* ent , float x , float y , float z , bool glob );
typedef void ( __cdecl *SCALEMESH ) (char* mesh , float sx , float sy , float sz );
typedef void ( __cdecl *SCALESPRITE ) (char* sprite , float s_x , float s_y );
typedef void ( __cdecl *SCALETEXTURE ) (char* tex , float u_scale , float v_scale );
typedef void ( __cdecl *SETANIMTIME ) (char* ent , float time , int seq );
typedef void ( __cdecl *SETCUBEFACE ) (char* tex , int face );
typedef void ( __cdecl *SETCUBEMODE ) (char* tex , int mode );
typedef void ( __cdecl *SHOWENTITY ) (char* ent );
typedef void ( __cdecl *SPRITEVIEWMODE ) (char* sprite , int mode );
typedef void ( __cdecl *STENCILALPHA ) (char* stencil , float a );
typedef void ( __cdecl *STENCILCLSCOLOR ) (char* stencil , float r , float g , float b );
typedef void ( __cdecl *STENCILMESH ) (char* stencil , char* mesh , int mode );
typedef void ( __cdecl *STENCILMODE ) (char* stencil , int m , int o );
typedef float ( __cdecl *TERRAINHEIGHT ) (char* terr , int x , int z );
typedef float ( __cdecl *TERRAINX ) (char* terr , float x , float y , float z );
typedef float ( __cdecl *TERRAINY ) (char* terr , float x , float y , float z );
typedef float ( __cdecl *TERRAINZ ) (char* terr , float x , float y , float z );
typedef void ( __cdecl *TEXTUREBLEND ) (char* tex , int blend );
typedef void ( __cdecl *TEXTURECOORDS ) (char* tex , int coords );
typedef int ( __cdecl *TEXTUREHEIGHT ) (char* tex );
typedef void ( __cdecl *TEXTUREFILTER ) (char* match_text , int flags );
typedef int ( __cdecl *TEXTUREWIDTH ) (char* tex );
typedef float ( __cdecl *TFORMEDX ) (void   );
typedef float ( __cdecl *TFORMEDY ) (void   );
typedef float ( __cdecl *TFORMEDZ ) (void   );
typedef void ( __cdecl *TFORMNORMAL ) (float x , float y , float z , char* src_ent , char* dest_ent );
typedef void ( __cdecl *TFORMPOINT ) (float x , float y , float z , char* src_ent , char* dest_ent );
typedef void ( __cdecl *TFORMVECTOR ) (float x , float y , float z , char* src_ent , char* dest_ent );
typedef void ( __cdecl *TRANSLATEENTITY ) (char* ent , float x , float y , float z , bool glob );
typedef int ( __cdecl *TRIANGLEVERTEX ) (char* surf , int tri_no , int corner );
typedef void ( __cdecl *TURNENTITY ) (char* ent , float x , float y , float z , bool glob );
typedef void ( __cdecl *UPDATENORMALS ) (char* mesh );
typedef void ( __cdecl *UPDATETEXCOORDS ) (char* surf );
typedef void ( __cdecl *UPDATEWORLD ) (float anim_speed );
typedef void ( __cdecl *USESTENCIL ) (char* stencil );
typedef float ( __cdecl *VECTORPITCH ) (float vx , float vy , float vz );
typedef float ( __cdecl *VECTORYAW ) (float vx , float vy , float vz );
typedef float ( __cdecl *VERTEXALPHA ) (char* surf , int vid );
typedef float ( __cdecl *VERTEXBLUE ) (char* surf , int vid );
typedef void ( __cdecl *VERTEXCOLOR ) (char* surf , int vid , float r , float g , float b , float a );
typedef void ( __cdecl *VERTEXCOORDS ) (char* surf , int vid , float x , float y , float z );
typedef float ( __cdecl *VERTEXGREEN ) (char* surf , int vid );
typedef void ( __cdecl *VERTEXNORMAL ) (char* surf , int vid , float nx , float ny , float nz );
typedef float ( __cdecl *VERTEXNX ) (char* surf , int vid );
typedef float ( __cdecl *VERTEXNY ) (char* surf , int vid );
typedef float ( __cdecl *VERTEXNZ ) (char* surf , int vid );
typedef float ( __cdecl *VERTEXRED ) (char* surf , int vid );
typedef void ( __cdecl *VERTEXTEXCOORDS ) (char* surf , int vid , float u , float v , float w , int coord_set );
typedef float ( __cdecl *VERTEXU ) (char* surf , int vid , int coord_set );
typedef float ( __cdecl *VERTEXV ) (char* surf , int vid , int coord_set );
typedef float ( __cdecl *VERTEXW ) (char* surf , int vid , int coord_set );
typedef float ( __cdecl *VERTEXX ) (char* surf , int vid );
typedef float ( __cdecl *VERTEXY ) (char* surf , int vid );
typedef float ( __cdecl *VERTEXZ ) (char* surf , int vid );
typedef void ( __cdecl *VOXELSPRITEMATERIAL ) (char* voxelspr , char* mat );
typedef void ( __cdecl *WIREFRAME ) (int enable );
typedef float ( __cdecl *ENTITYSCALEX ) (char* ent , bool glob );
typedef float ( __cdecl *ENTITYSCALEY ) (char* ent , bool glob );
typedef float ( __cdecl *ENTITYSCALEZ ) (char* ent , bool glob );
typedef char* ( __cdecl *LOADSHADER ) (char* ShaderName , char* VshaderFileName , char* FshaderFileName );
typedef char* ( __cdecl *CREATESHADER ) (char* ShaderName , char* VshaderString , char* FshaderString );
typedef void ( __cdecl *SHADESURFACE ) (char* surf , char* material );
typedef void ( __cdecl *SHADEMESH ) (char* mesh , char* material );
typedef void ( __cdecl *SHADEENTITY ) (char* ent , char* material );
typedef void ( __cdecl *SHADERTEXTURE ) (char* material , char* tex , char* name , int index );
typedef void ( __cdecl *SETFLOAT ) (char* material , char* name , float v1 );
typedef void ( __cdecl *SETFLOAT2 ) (char* material , char* name , float v1 , float v2 );
typedef void ( __cdecl *SETFLOAT3 ) (char* material , char* name , float v1 , float v2 , float v3 );
typedef void ( __cdecl *SETFLOAT4 ) (char* material , char* name , float v1 , float v2 , float v3 , float v4 );
typedef void ( __cdecl *USEFLOAT ) (char* material , char* name , float* v1 );
typedef void ( __cdecl *USEFLOAT2 ) (char* material , char* name , float* v1 , float* v2 );
typedef void ( __cdecl *USEFLOAT3 ) (char* material , char* name , float* v1 , float* v2 , float* v3 );
typedef void ( __cdecl *USEFLOAT4 ) (char* material , char* name , float* v1 , float* v2 , float* v3 , float* v4 );
typedef void ( __cdecl *SETINTEGER ) (char* material , char* name , int v1 );
typedef void ( __cdecl *SETINTEGER2 ) (char* material , char* name , int v1 , int v2 );
typedef void ( __cdecl *SETINTEGER3 ) (char* material , char* name , int v1 , int v2 , int v3 );
typedef void ( __cdecl *SETINTEGER4 ) (char* material , char* name , int v1 , int v2 , int v3 , int v4 );
typedef void ( __cdecl *USEINTEGER ) (char* material , char* name , int* v1 );
typedef void ( __cdecl *USEINTEGER2 ) (char* material , char* name , int* v1 , int* v2 );
typedef void ( __cdecl *USEINTEGER3 ) (char* material , char* name , int* v1 , int* v2 , int* v3 );
typedef void ( __cdecl *USEINTEGER4 ) (char* material , char* name , int* v1 , int* v2 , int* v3 , int* v4 );
typedef void ( __cdecl *USESURFACE ) (char* material , char* name , char* surf , int vbo );
typedef void ( __cdecl *USEMATRIX ) (char* material , char* name , int mode );
typedef char* ( __cdecl *LOADMATERIAL ) (char* filename , int flags , int frame_width , int frame_height , int first_frame , int frame_count );
typedef void ( __cdecl *SHADERMATERIAL ) (char* material , char* tex , char* name , int index );
typedef char* ( __cdecl *CREATEOCTREE ) (float w , float h , float d , char* parent_ent );
typedef void ( __cdecl *ADDTOOCTREE ) (char* octree , char* mesh , int level , float X , float Y , float Z , float Near , float Far );


extern BUFFERTOTEX _BufferToTex;
extern BACKBUFFERTOTEX _BackBufferToTex;
extern TEXTOBUFFER _TexToBuffer;
extern MESHCULLRADIUS _MeshCullRadius;
extern ADDANIMSEQ _AddAnimSeq;
extern ADDMESH _AddMesh;
extern ADDTRIANGLE _AddTriangle;
extern ADDVERTEX _AddVertex;
extern AMBIENTLIGHT _AmbientLight;
extern ANTIALIAS _AntiAlias;
extern ANIMATE _Animate;
extern ANIMATING _Animating;
extern ANIMLENGTH _AnimLength;
extern ANIMSEQ _AnimSeq;
extern ANIMTIME _AnimTime;
extern BRUSHALPHA _BrushAlpha;
extern BRUSHBLEND _BrushBlend;
extern BRUSHCOLOR _BrushColor;
extern BRUSHFX _BrushFX;
extern BRUSHSHININESS _BrushShininess;
extern BRUSHTEXTURE _BrushTexture;
extern CAMERACLSCOLOR _CameraClsColor;
extern CAMERACLSMODE _CameraClsMode;
extern CAMERAFOGCOLOR _CameraFogColor;
extern CAMERAFOGMODE _CameraFogMode;
extern CAMERAFOGRANGE _CameraFogRange;
extern CAMERAPICK _CameraPick;
extern CAMERAPROJECT _CameraProject;
extern CAMERAPROJMODE _CameraProjMode;
extern CAMERARANGE _CameraRange;
extern CAMERAVIEWPORT _CameraViewport;
extern CAMERAZOOM _CameraZoom;
extern CLEARCOLLISIONS _ClearCollisions;
extern CLEARSURFACE _ClearSurface;
extern CLEARTEXTUREFILTERS _ClearTextureFilters;
extern CLEARWORLD _ClearWorld;
extern COLLISIONENTITY _CollisionEntity;
extern COLLISIONS _Collisions;
extern COLLISIONNX _CollisionNX;
extern COLLISIONNY _CollisionNY;
extern COLLISIONNZ _CollisionNZ;
extern COLLISIONSURFACE _CollisionSurface;
extern COLLISIONTIME _CollisionTime;
extern COLLISIONTRIANGLE _CollisionTriangle;
extern COLLISIONX _CollisionX;
extern COLLISIONY _CollisionY;
extern COLLISIONZ _CollisionZ;
extern COUNTCHILDREN _CountChildren;
extern COUNTCOLLISIONS _CountCollisions;
extern COPYENTITY _CopyEntity;
extern COPYMESH _CopyMesh;
extern COUNTSURFACES _CountSurfaces;
extern COUNTTRIANGLES _CountTriangles;
extern COUNTVERTICES _CountVertices;
extern CREATEBRUSH _CreateBrush;
extern CREATECAMERA _CreateCamera;
extern CREATECONE _CreateCone;
extern CREATECYLINDER _CreateCylinder;
extern CREATECUBE _CreateCube;
extern CREATEMESH _CreateMesh;
extern CREATELIGHT _CreateLight;
extern CREATEPIVOT _CreatePivot;
extern CREATEPLANE _CreatePlane;
extern CREATESHADOW _CreateShadow;
extern CREATESPHERE _CreateSphere;
extern CREATESPRITE _CreateSprite;
extern CREATESURFACE _CreateSurface;
extern CREATESTENCIL _CreateStencil;
extern CREATETERRAIN _CreateTerrain;
extern CREATETEXTURE _CreateTexture;
extern CREATEVOXELSPRITE _CreateVoxelSprite;
extern DELTAPITCH _DeltaPitch;
extern DELTAYAW _DeltaYaw;
extern ENTITYALPHA _EntityAlpha;
extern ENTITYAUTOFADE _EntityAutoFade;
extern ENTITYBLEND _EntityBlend;
extern ENTITYBOX _EntityBox;
extern ENTITYCOLLIDED _EntityCollided;
extern ENTITYCOLOR _EntityColor;
extern ENTITYDISTANCE _EntityDistance;
extern ENTITYFX _EntityFX;
extern ENTITYINVIEW _EntityInView;
extern ENTITYORDER _EntityOrder;
extern ENTITYPARENT _EntityParent;
extern ENTITYPICK _EntityPick;
extern ENTITYPICKMODE _EntityPickMode;
extern ENTITYPITCH _EntityPitch;
extern ENTITYRADIUS _EntityRadius;
extern ENTITYROLL _EntityRoll;
extern ENTITYSHININESS _EntityShininess;
extern ENTITYTEXTURE _EntityTexture;
extern ENTITYTYPE _EntityType;
extern ENTITYVISIBLE _EntityVisible;
extern ENTITYX _EntityX;
extern ENTITYY _EntityY;
extern ENTITYYAW _EntityYaw;
extern ENTITYZ _EntityZ;
extern EXTRACTANIMSEQ _ExtractAnimSeq;
extern FINDCHILD _FindChild;
extern FINDSURFACE _FindSurface;
extern FITMESH _FitMesh;
extern FLIPMESH _FlipMesh;
extern FREEBRUSH _FreeBrush;
extern FREEENTITY _FreeEntity;
extern FREESHADOW _FreeShadow;
extern FREETEXTURE _FreeTexture;
extern GETBRUSHTEXTURE _GetBrushTexture;
extern GETCHILD _GetChild;
extern GETENTITYBRUSH _GetEntityBrush;
extern GETENTITYTYPE _GetEntityType;
extern GETMATELEMENT _GetMatElement;
extern GETPARENTENTITY _GetParentEntity;
extern GETSURFACE _GetSurface;
extern GETSURFACEBRUSH _GetSurfaceBrush;
extern GRAPHICS3D _Graphics3D;
extern GRAPHICSRESIZE _GraphicsResize;
extern HANDLESPRITE _HandleSprite;
extern HIDEENTITY _HideEntity;
extern LIGHTCOLOR _LightColor;
extern LIGHTCONEANGLES _LightConeAngles;
extern LIGHTRANGE _LightRange;
extern LINEPICK _LinePick;
extern LOADANIMMESH _LoadAnimMesh;
extern LOADANIMTEXTURE _LoadAnimTexture;
extern LOADBRUSH _LoadBrush;
extern LOADMESH _LoadMesh;
extern LOADTERRAIN _LoadTerrain;
extern LOADTEXTURE _LoadTexture;
extern LOADSPRITE _LoadSprite;
extern MESHCSG _MeshCSG;
extern MESHDEPTH _MeshDepth;
extern MESHESINTERSECT _MeshesIntersect;
extern MESHHEIGHT _MeshHeight;
extern MESHWIDTH _MeshWidth;
extern MODIFYTERRAIN _ModifyTerrain;
extern MOVEENTITY _MoveEntity;
extern NAMEENTITY _NameEntity;
extern PAINTENTITY _PaintEntity;
extern PAINTMESH _PaintMesh;
extern PAINTSURFACE _PaintSurface;
extern PICKEDENTITY _PickedEntity;
extern PICKEDNX _PickedNX;
extern PICKEDNY _PickedNY;
extern PICKEDNZ _PickedNZ;
extern PICKEDSURFACE _PickedSurface;
extern PICKEDTIME _PickedTime;
extern PICKEDTRIANGLE _PickedTriangle;
extern PICKEDX _PickedX;
extern PICKEDY _PickedY;
extern PICKEDZ _PickedZ;
extern POINTENTITY _PointEntity;
extern POSITIONENTITY _PositionEntity;
extern POSITIONMESH _PositionMesh;
extern POSITIONTEXTURE _PositionTexture;
extern PROJECTEDX _ProjectedX;
extern PROJECTEDY _ProjectedY;
extern PROJECTEDZ _ProjectedZ;
extern RENDERWORLD _RenderWorld;
extern REPEATMESH _RepeatMesh;
extern RESETENTITY _ResetEntity;
extern ROTATEENTITY _RotateEntity;
extern ROTATEMESH _RotateMesh;
extern ROTATESPRITE _RotateSprite;
extern ROTATETEXTURE _RotateTexture;
extern SCALEENTITY _ScaleEntity;
extern SCALEMESH _ScaleMesh;
extern SCALESPRITE _ScaleSprite;
extern SCALETEXTURE _ScaleTexture;
extern SETANIMTIME _SetAnimTime;
extern SETCUBEFACE _SetCubeFace;
extern SETCUBEMODE _SetCubeMode;
extern SHOWENTITY _ShowEntity;
extern SPRITEVIEWMODE _SpriteViewMode;
extern STENCILALPHA _StencilAlpha;
extern STENCILCLSCOLOR _StencilClsColor;
extern STENCILMESH _StencilMesh;
extern STENCILMODE _StencilMode;
extern TERRAINHEIGHT _TerrainHeight;
extern TERRAINX _TerrainX;
extern TERRAINY _TerrainY;
extern TERRAINZ _TerrainZ;
extern TEXTUREBLEND _TextureBlend;
extern TEXTURECOORDS _TextureCoords;
extern TEXTUREHEIGHT _TextureHeight;
extern TEXTUREFILTER _TextureFilter;
extern TEXTUREWIDTH _TextureWidth;
extern TFORMEDX _TFormedX;
extern TFORMEDY _TFormedY;
extern TFORMEDZ _TFormedZ;
extern TFORMNORMAL _TFormNormal;
extern TFORMPOINT _TFormPoint;
extern TFORMVECTOR _TFormVector;
extern TRANSLATEENTITY _TranslateEntity;
extern TRIANGLEVERTEX _TriangleVertex;
extern TURNENTITY _TurnEntity;
extern UPDATENORMALS _UpdateNormals;
extern UPDATETEXCOORDS _UpdateTexCoords;
extern UPDATEWORLD _UpdateWorld;
extern USESTENCIL _UseStencil;
extern VECTORPITCH _VectorPitch;
extern VECTORYAW _VectorYaw;
extern VERTEXALPHA _VertexAlpha;
extern VERTEXBLUE _VertexBlue;
extern VERTEXCOLOR _VertexColor;
extern VERTEXCOORDS _VertexCoords;
extern VERTEXGREEN _VertexGreen;
extern VERTEXNORMAL _VertexNormal;
extern VERTEXNX _VertexNX;
extern VERTEXNY _VertexNY;
extern VERTEXNZ _VertexNZ;
extern VERTEXRED _VertexRed;
extern VERTEXTEXCOORDS _VertexTexCoords;
extern VERTEXU _VertexU;
extern VERTEXV _VertexV;
extern VERTEXW _VertexW;
extern VERTEXX _VertexX;
extern VERTEXY _VertexY;
extern VERTEXZ _VertexZ;
extern VOXELSPRITEMATERIAL _VoxelSpriteMaterial;
extern WIREFRAME _Wireframe;
extern ENTITYSCALEX _EntityScaleX;
extern ENTITYSCALEY _EntityScaleY;
extern ENTITYSCALEZ _EntityScaleZ;
extern LOADSHADER _LoadShader;
extern CREATESHADER _CreateShader;
extern SHADESURFACE _ShadeSurface;
extern SHADEMESH _ShadeMesh;
extern SHADEENTITY _ShadeEntity;
extern SHADERTEXTURE _ShaderTexture;
extern SETFLOAT _SetFloat;
extern SETFLOAT2 _SetFloat2;
extern SETFLOAT3 _SetFloat3;
extern SETFLOAT4 _SetFloat4;
extern USEFLOAT _UseFloat;
extern USEFLOAT2 _UseFloat2;
extern USEFLOAT3 _UseFloat3;
extern USEFLOAT4 _UseFloat4;
extern SETINTEGER _SetInteger;
extern SETINTEGER2 _SetInteger2;
extern SETINTEGER3 _SetInteger3;
extern SETINTEGER4 _SetInteger4;
extern USEINTEGER _UseInteger;
extern USEINTEGER2 _UseInteger2;
extern USEINTEGER3 _UseInteger3;
extern USEINTEGER4 _UseInteger4;
extern USESURFACE _UseSurface;
extern USEMATRIX _UseMatrix;
extern LOADMATERIAL _LoadMaterial;
extern SHADERMATERIAL _ShaderMaterial;
extern CREATEOCTREE _CreateOcTree;
extern ADDTOOCTREE _AddToOctree;


BUFFERTOTEX _BufferToTex;
BACKBUFFERTOTEX _BackBufferToTex;
TEXTOBUFFER _TexToBuffer;
MESHCULLRADIUS _MeshCullRadius;
ADDANIMSEQ _AddAnimSeq;
ADDMESH _AddMesh;
ADDTRIANGLE _AddTriangle;
ADDVERTEX _AddVertex;
AMBIENTLIGHT _AmbientLight;
ANTIALIAS _AntiAlias;
ANIMATE _Animate;
ANIMATING _Animating;
ANIMLENGTH _AnimLength;
ANIMSEQ _AnimSeq;
ANIMTIME _AnimTime;
BRUSHALPHA _BrushAlpha;
BRUSHBLEND _BrushBlend;
BRUSHCOLOR _BrushColor;
BRUSHFX _BrushFX;
BRUSHSHININESS _BrushShininess;
BRUSHTEXTURE _BrushTexture;
CAMERACLSCOLOR _CameraClsColor;
CAMERACLSMODE _CameraClsMode;
CAMERAFOGCOLOR _CameraFogColor;
CAMERAFOGMODE _CameraFogMode;
CAMERAFOGRANGE _CameraFogRange;
CAMERAPICK _CameraPick;
CAMERAPROJECT _CameraProject;
CAMERAPROJMODE _CameraProjMode;
CAMERARANGE _CameraRange;
CAMERAVIEWPORT _CameraViewport;
CAMERAZOOM _CameraZoom;
CLEARCOLLISIONS _ClearCollisions;
CLEARSURFACE _ClearSurface;
CLEARTEXTUREFILTERS _ClearTextureFilters;
CLEARWORLD _ClearWorld;
COLLISIONENTITY _CollisionEntity;
COLLISIONS _Collisions;
COLLISIONNX _CollisionNX;
COLLISIONNY _CollisionNY;
COLLISIONNZ _CollisionNZ;
COLLISIONSURFACE _CollisionSurface;
COLLISIONTIME _CollisionTime;
COLLISIONTRIANGLE _CollisionTriangle;
COLLISIONX _CollisionX;
COLLISIONY _CollisionY;
COLLISIONZ _CollisionZ;
COUNTCHILDREN _CountChildren;
COUNTCOLLISIONS _CountCollisions;
COPYENTITY _CopyEntity;
COPYMESH _CopyMesh;
COUNTSURFACES _CountSurfaces;
COUNTTRIANGLES _CountTriangles;
COUNTVERTICES _CountVertices;
CREATEBRUSH _CreateBrush;
CREATECAMERA _CreateCamera;
CREATECONE _CreateCone;
CREATECYLINDER _CreateCylinder;
CREATECUBE _CreateCube;
CREATEMESH _CreateMesh;
CREATELIGHT _CreateLight;
CREATEPIVOT _CreatePivot;
CREATEPLANE _CreatePlane;
CREATESHADOW _CreateShadow;
CREATESPHERE _CreateSphere;
CREATESPRITE _CreateSprite;
CREATESURFACE _CreateSurface;
CREATESTENCIL _CreateStencil;
CREATETERRAIN _CreateTerrain;
CREATETEXTURE _CreateTexture;
CREATEVOXELSPRITE _CreateVoxelSprite;
DELTAPITCH _DeltaPitch;
DELTAYAW _DeltaYaw;
ENTITYALPHA _EntityAlpha;
ENTITYAUTOFADE _EntityAutoFade;
ENTITYBLEND _EntityBlend;
ENTITYBOX _EntityBox;
ENTITYCOLLIDED _EntityCollided;
ENTITYCOLOR _EntityColor;
ENTITYDISTANCE _EntityDistance;
ENTITYFX _EntityFX;
ENTITYINVIEW _EntityInView;
ENTITYORDER _EntityOrder;
ENTITYPARENT _EntityParent;
ENTITYPICK _EntityPick;
ENTITYPICKMODE _EntityPickMode;
ENTITYPITCH _EntityPitch;
ENTITYRADIUS _EntityRadius;
ENTITYROLL _EntityRoll;
ENTITYSHININESS _EntityShininess;
ENTITYTEXTURE _EntityTexture;
ENTITYTYPE _EntityType;
ENTITYVISIBLE _EntityVisible;
ENTITYX _EntityX;
ENTITYY _EntityY;
ENTITYYAW _EntityYaw;
ENTITYZ _EntityZ;
EXTRACTANIMSEQ _ExtractAnimSeq;
FINDCHILD _FindChild;
FINDSURFACE _FindSurface;
FITMESH _FitMesh;
FLIPMESH _FlipMesh;
FREEBRUSH _FreeBrush;
FREEENTITY _FreeEntity;
FREESHADOW _FreeShadow;
FREETEXTURE _FreeTexture;
GETBRUSHTEXTURE _GetBrushTexture;
GETCHILD _GetChild;
GETENTITYBRUSH _GetEntityBrush;
GETENTITYTYPE _GetEntityType;
GETMATELEMENT _GetMatElement;
GETPARENTENTITY _GetParentEntity;
GETSURFACE _GetSurface;
GETSURFACEBRUSH _GetSurfaceBrush;
GRAPHICS3D _Graphics3D;
GRAPHICSRESIZE _GraphicsResize;
HANDLESPRITE _HandleSprite;
HIDEENTITY _HideEntity;
LIGHTCOLOR _LightColor;
LIGHTCONEANGLES _LightConeAngles;
LIGHTRANGE _LightRange;
LINEPICK _LinePick;
LOADANIMMESH _LoadAnimMesh;
LOADANIMTEXTURE _LoadAnimTexture;
LOADBRUSH _LoadBrush;
LOADMESH _LoadMesh;
LOADTERRAIN _LoadTerrain;
LOADTEXTURE _LoadTexture;
LOADSPRITE _LoadSprite;
MESHCSG _MeshCSG;
MESHDEPTH _MeshDepth;
MESHESINTERSECT _MeshesIntersect;
MESHHEIGHT _MeshHeight;
MESHWIDTH _MeshWidth;
MODIFYTERRAIN _ModifyTerrain;
MOVEENTITY _MoveEntity;
NAMEENTITY _NameEntity;
PAINTENTITY _PaintEntity;
PAINTMESH _PaintMesh;
PAINTSURFACE _PaintSurface;
PICKEDENTITY _PickedEntity;
PICKEDNX _PickedNX;
PICKEDNY _PickedNY;
PICKEDNZ _PickedNZ;
PICKEDSURFACE _PickedSurface;
PICKEDTIME _PickedTime;
PICKEDTRIANGLE _PickedTriangle;
PICKEDX _PickedX;
PICKEDY _PickedY;
PICKEDZ _PickedZ;
POINTENTITY _PointEntity;
POSITIONENTITY _PositionEntity;
POSITIONMESH _PositionMesh;
POSITIONTEXTURE _PositionTexture;
PROJECTEDX _ProjectedX;
PROJECTEDY _ProjectedY;
PROJECTEDZ _ProjectedZ;
RENDERWORLD _RenderWorld;
REPEATMESH _RepeatMesh;
RESETENTITY _ResetEntity;
ROTATEENTITY _RotateEntity;
ROTATEMESH _RotateMesh;
ROTATESPRITE _RotateSprite;
ROTATETEXTURE _RotateTexture;
SCALEENTITY _ScaleEntity;
SCALEMESH _ScaleMesh;
SCALESPRITE _ScaleSprite;
SCALETEXTURE _ScaleTexture;
SETANIMTIME _SetAnimTime;
SETCUBEFACE _SetCubeFace;
SETCUBEMODE _SetCubeMode;
SHOWENTITY _ShowEntity;
SPRITEVIEWMODE _SpriteViewMode;
STENCILALPHA _StencilAlpha;
STENCILCLSCOLOR _StencilClsColor;
STENCILMESH _StencilMesh;
STENCILMODE _StencilMode;
TERRAINHEIGHT _TerrainHeight;
TERRAINX _TerrainX;
TERRAINY _TerrainY;
TERRAINZ _TerrainZ;
TEXTUREBLEND _TextureBlend;
TEXTURECOORDS _TextureCoords;
TEXTUREHEIGHT _TextureHeight;
TEXTUREFILTER _TextureFilter;
TEXTUREWIDTH _TextureWidth;
TFORMEDX _TFormedX;
TFORMEDY _TFormedY;
TFORMEDZ _TFormedZ;
TFORMNORMAL _TFormNormal;
TFORMPOINT _TFormPoint;
TFORMVECTOR _TFormVector;
TRANSLATEENTITY _TranslateEntity;
TRIANGLEVERTEX _TriangleVertex;
TURNENTITY _TurnEntity;
UPDATENORMALS _UpdateNormals;
UPDATETEXCOORDS _UpdateTexCoords;
UPDATEWORLD _UpdateWorld;
USESTENCIL _UseStencil;
VECTORPITCH _VectorPitch;
VECTORYAW _VectorYaw;
VERTEXALPHA _VertexAlpha;
VERTEXBLUE _VertexBlue;
VERTEXCOLOR _VertexColor;
VERTEXCOORDS _VertexCoords;
VERTEXGREEN _VertexGreen;
VERTEXNORMAL _VertexNormal;
VERTEXNX _VertexNX;
VERTEXNY _VertexNY;
VERTEXNZ _VertexNZ;
VERTEXRED _VertexRed;
VERTEXTEXCOORDS _VertexTexCoords;
VERTEXU _VertexU;
VERTEXV _VertexV;
VERTEXW _VertexW;
VERTEXX _VertexX;
VERTEXY _VertexY;
VERTEXZ _VertexZ;
VOXELSPRITEMATERIAL _VoxelSpriteMaterial;
WIREFRAME _Wireframe;
ENTITYSCALEX _EntityScaleX;
ENTITYSCALEY _EntityScaleY;
ENTITYSCALEZ _EntityScaleZ;
LOADSHADER _LoadShader;
CREATESHADER _CreateShader;
SHADESURFACE _ShadeSurface;
SHADEMESH _ShadeMesh;
SHADEENTITY _ShadeEntity;
SHADERTEXTURE _ShaderTexture;
SETFLOAT _SetFloat;
SETFLOAT2 _SetFloat2;
SETFLOAT3 _SetFloat3;
SETFLOAT4 _SetFloat4;
USEFLOAT _UseFloat;
USEFLOAT2 _UseFloat2;
USEFLOAT3 _UseFloat3;
USEFLOAT4 _UseFloat4;
SETINTEGER _SetInteger;
SETINTEGER2 _SetInteger2;
SETINTEGER3 _SetInteger3;
SETINTEGER4 _SetInteger4;
USEINTEGER _UseInteger;
USEINTEGER2 _UseInteger2;
USEINTEGER3 _UseInteger3;
USEINTEGER4 _UseInteger4;
USESURFACE _UseSurface;
USEMATRIX _UseMatrix;
LOADMATERIAL _LoadMaterial;
SHADERMATERIAL _ShaderMaterial;
CREATEOCTREE _CreateOcTree;
ADDTOOCTREE _AddToOctree;


// Graphics3D command creates the openGL context in our window the cals Graphics3D
// requires the string of the window
// in future I would like to use windowID but for the purposes of this I will use "FindWindowA()"

LC_ENTRY (Graphics3D)
{
	// we need a few arguments to start the engine
	//window title, height, width
	// depth mode and rate are optional
	LC_ARG_COUNT(3);
	hWnd = FindWindowA(NULL,p_arguments[0]);
	// get the device context (DC)
    hDC = GetDC( hWnd );

	// create our opengl context manually (win32 only)
	PIXELFORMATDESCRIPTOR pfd;
    int iFormat;
    // set the pixel format for the DC
    ZeroMemory( &pfd, sizeof( pfd ) );
    pfd.nSize = sizeof( pfd );
    pfd.nVersion = 1;
    pfd.dwFlags = PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL |
                  PFD_DOUBLEBUFFER | PFD_TYPE_RGBA | PFD_SUPPORT_GDI;
    pfd.iPixelType = PFD_TYPE_RGBA;
    pfd.cColorBits = 24;
    pfd.cDepthBits = 16;
	pfd.cStencilBits = 8;
    pfd.iLayerType = PFD_MAIN_PLANE;
    iFormat = ChoosePixelFormat( hDC, &pfd );
    SetPixelFormat( hDC, iFormat, &pfd );
    // create and enable the render context (RC)
    hRC = wglCreateContext( hDC );
    wglMakeCurrent( hDC, hRC );
	if (!hRC) LC_ERROR("Unable to Create OpenGL Context!");

	// load openb3d.dll for explicit linking...
	dll = LoadLibraryA( "openb3d.dll" );
	if ( !dll ) LC_ERROR( "Unable to Load Dll" );

	// explicitly link the functions within openb3d and map them to our function pointers...
	_BufferToTex = ( BUFFERTOTEX ) GetProcAddress ( dll, "BufferToTex" );
	_BackBufferToTex = ( BACKBUFFERTOTEX ) GetProcAddress ( dll, "BackBufferToTex" );
	_TexToBuffer = ( TEXTOBUFFER ) GetProcAddress ( dll, "TexToBuffer" );
	_MeshCullRadius = ( MESHCULLRADIUS ) GetProcAddress ( dll, "MeshCullRadius" );
	_AddAnimSeq = ( ADDANIMSEQ ) GetProcAddress ( dll, "AddAnimSeq" );
	_AddMesh = ( ADDMESH ) GetProcAddress ( dll, "AddMesh" );
	_AddTriangle = ( ADDTRIANGLE ) GetProcAddress ( dll, "AddTriangle" );
	_AddVertex = ( ADDVERTEX ) GetProcAddress ( dll, "AddVertex" );
	_AmbientLight = ( AMBIENTLIGHT ) GetProcAddress ( dll, "AmbientLight" );
	_AntiAlias = ( ANTIALIAS ) GetProcAddress ( dll, "AntiAlias" );
	_Animate = ( ANIMATE ) GetProcAddress ( dll, "Animate" );
	_Animating = ( ANIMATING ) GetProcAddress ( dll, "Animating" );
	_AnimLength = ( ANIMLENGTH ) GetProcAddress ( dll, "AnimLength" );
	_AnimSeq = ( ANIMSEQ ) GetProcAddress ( dll, "AnimSeq" );
	_AnimTime = ( ANIMTIME ) GetProcAddress ( dll, "AnimTime" );
	_BrushAlpha = ( BRUSHALPHA ) GetProcAddress ( dll, "BrushAlpha" );
	_BrushBlend = ( BRUSHBLEND ) GetProcAddress ( dll, "BrushBlend" );
	_BrushColor = ( BRUSHCOLOR ) GetProcAddress ( dll, "BrushColor" );
	_BrushFX = ( BRUSHFX ) GetProcAddress ( dll, "BrushFX" );
	_BrushShininess = ( BRUSHSHININESS ) GetProcAddress ( dll, "BrushShininess" );
	_BrushTexture = ( BRUSHTEXTURE ) GetProcAddress ( dll, "BrushTexture" );
	_CameraClsColor = ( CAMERACLSCOLOR ) GetProcAddress ( dll, "CameraClsColor" );
	_CameraClsMode = ( CAMERACLSMODE ) GetProcAddress ( dll, "CameraClsMode" );
	_CameraFogColor = ( CAMERAFOGCOLOR ) GetProcAddress ( dll, "CameraFogColor" );
	_CameraFogMode = ( CAMERAFOGMODE ) GetProcAddress ( dll, "CameraFogMode" );
	_CameraFogRange = ( CAMERAFOGRANGE ) GetProcAddress ( dll, "CameraFogRange" );
	_CameraPick = ( CAMERAPICK ) GetProcAddress ( dll, "CameraPick" );
	_CameraProject = ( CAMERAPROJECT ) GetProcAddress ( dll, "CameraProject" );
	_CameraProjMode = ( CAMERAPROJMODE ) GetProcAddress ( dll, "CameraProjMode" );
	_CameraRange = ( CAMERARANGE ) GetProcAddress ( dll, "CameraRange" );
	_CameraViewport = ( CAMERAVIEWPORT ) GetProcAddress ( dll, "CameraViewport" );
	_CameraZoom = ( CAMERAZOOM ) GetProcAddress ( dll, "CameraZoom" );
	_ClearCollisions = ( CLEARCOLLISIONS ) GetProcAddress ( dll, "ClearCollisions" );
	_ClearSurface = ( CLEARSURFACE ) GetProcAddress ( dll, "ClearSurface" );
	_ClearTextureFilters = ( CLEARTEXTUREFILTERS ) GetProcAddress ( dll, "ClearTextureFilters" );
	_ClearWorld = ( CLEARWORLD ) GetProcAddress ( dll, "ClearWorld" );
	_CollisionEntity = ( COLLISIONENTITY ) GetProcAddress ( dll, "CollisionEntity" );
	_Collisions = ( COLLISIONS ) GetProcAddress ( dll, "Collisions" );
	_CollisionNX = ( COLLISIONNX ) GetProcAddress ( dll, "CollisionNX" );
	_CollisionNY = ( COLLISIONNY ) GetProcAddress ( dll, "CollisionNY" );
	_CollisionNZ = ( COLLISIONNZ ) GetProcAddress ( dll, "CollisionNZ" );
	_CollisionSurface = ( COLLISIONSURFACE ) GetProcAddress ( dll, "CollisionSurface" );
	_CollisionTime = ( COLLISIONTIME ) GetProcAddress ( dll, "CollisionTime" );
	_CollisionTriangle = ( COLLISIONTRIANGLE ) GetProcAddress ( dll, "CollisionTriangle" );
	_CollisionX = ( COLLISIONX ) GetProcAddress ( dll, "CollisionX" );
	_CollisionY = ( COLLISIONY ) GetProcAddress ( dll, "CollisionY" );
	_CollisionZ = ( COLLISIONZ ) GetProcAddress ( dll, "CollisionZ" );
	_CountChildren = ( COUNTCHILDREN ) GetProcAddress ( dll, "CountChildren" );
	_CountCollisions = ( COUNTCOLLISIONS ) GetProcAddress ( dll, "CountCollisions" );
	_CopyEntity = ( COPYENTITY ) GetProcAddress ( dll, "CopyEntity" );
	_CopyMesh = ( COPYMESH ) GetProcAddress ( dll, "CopyMesh" );
	_CountSurfaces = ( COUNTSURFACES ) GetProcAddress ( dll, "CountSurfaces" );
	_CountTriangles = ( COUNTTRIANGLES ) GetProcAddress ( dll, "CountTriangles" );
	_CountVertices = ( COUNTVERTICES ) GetProcAddress ( dll, "CountVertices" );
	_CreateBrush = ( CREATEBRUSH ) GetProcAddress ( dll, "CreateBrush" );
	_CreateCamera = ( CREATECAMERA ) GetProcAddress ( dll, "CreateCamera" );
	_CreateCone = ( CREATECONE ) GetProcAddress ( dll, "CreateCone" );
	_CreateCylinder = ( CREATECYLINDER ) GetProcAddress ( dll, "CreateCylinder" );
	_CreateCube = ( CREATECUBE ) GetProcAddress ( dll, "CreateCube" );
	_CreateMesh = ( CREATEMESH ) GetProcAddress ( dll, "CreateMesh" );
	_CreateLight = ( CREATELIGHT ) GetProcAddress ( dll, "CreateLight" );
	_CreatePivot = ( CREATEPIVOT ) GetProcAddress ( dll, "CreatePivot" );
	_CreatePlane = ( CREATEPLANE ) GetProcAddress ( dll, "CreatePlane" );
	_CreateShadow = ( CREATESHADOW ) GetProcAddress ( dll, "CreateShadow" );
	_CreateSphere = ( CREATESPHERE ) GetProcAddress ( dll, "CreateSphere" );
	_CreateSprite = ( CREATESPRITE ) GetProcAddress ( dll, "CreateSprite" );
	_CreateSurface = ( CREATESURFACE ) GetProcAddress ( dll, "CreateSurface" );
	_CreateStencil = ( CREATESTENCIL ) GetProcAddress ( dll, "CreateStencil" );
	_CreateTerrain = ( CREATETERRAIN ) GetProcAddress ( dll, "CreateTerrain" );
	_CreateTexture = ( CREATETEXTURE ) GetProcAddress ( dll, "CreateTexture" );
	_CreateVoxelSprite = ( CREATEVOXELSPRITE ) GetProcAddress ( dll, "CreateVoxelSprite" );
	_DeltaPitch = ( DELTAPITCH ) GetProcAddress ( dll, "DeltaPitch" );
	_DeltaYaw = ( DELTAYAW ) GetProcAddress ( dll, "DeltaYaw" );
	_EntityAlpha = ( ENTITYALPHA ) GetProcAddress ( dll, "EntityAlpha" );
	_EntityAutoFade = ( ENTITYAUTOFADE ) GetProcAddress ( dll, "EntityAutoFade" );
	_EntityBlend = ( ENTITYBLEND ) GetProcAddress ( dll, "EntityBlend" );
	_EntityBox = ( ENTITYBOX ) GetProcAddress ( dll, "EntityBox" );
	_EntityCollided = ( ENTITYCOLLIDED ) GetProcAddress ( dll, "EntityCollided" );
	_EntityColor = ( ENTITYCOLOR ) GetProcAddress ( dll, "EntityColor" );
	_EntityDistance = ( ENTITYDISTANCE ) GetProcAddress ( dll, "EntityDistance" );
	_EntityFX = ( ENTITYFX ) GetProcAddress ( dll, "EntityFX" );
	_EntityInView = ( ENTITYINVIEW ) GetProcAddress ( dll, "EntityInView" );
	_EntityOrder = ( ENTITYORDER ) GetProcAddress ( dll, "EntityOrder" );
	_EntityParent = ( ENTITYPARENT ) GetProcAddress ( dll, "EntityParent" );
	_EntityPick = ( ENTITYPICK ) GetProcAddress ( dll, "EntityPick" );
	_EntityPickMode = ( ENTITYPICKMODE ) GetProcAddress ( dll, "EntityPickMode" );
	_EntityPitch = ( ENTITYPITCH ) GetProcAddress ( dll, "EntityPitch" );
	_EntityRadius = ( ENTITYRADIUS ) GetProcAddress ( dll, "EntityRadius" );
	_EntityRoll = ( ENTITYROLL ) GetProcAddress ( dll, "EntityRoll" );
	_EntityShininess = ( ENTITYSHININESS ) GetProcAddress ( dll, "EntityShininess" );
	_EntityTexture = ( ENTITYTEXTURE ) GetProcAddress ( dll, "EntityTexture" );
	_EntityType = ( ENTITYTYPE ) GetProcAddress ( dll, "EntityType" );
	_EntityVisible = ( ENTITYVISIBLE ) GetProcAddress ( dll, "EntityVisible" );
	_EntityX = ( ENTITYX ) GetProcAddress ( dll, "EntityX" );
	_EntityY = ( ENTITYY ) GetProcAddress ( dll, "EntityY" );
	_EntityYaw = ( ENTITYYAW ) GetProcAddress ( dll, "EntityYaw" );
	_EntityZ = ( ENTITYZ ) GetProcAddress ( dll, "EntityZ" );
	_ExtractAnimSeq = ( EXTRACTANIMSEQ ) GetProcAddress ( dll, "ExtractAnimSeq" );
	_FindChild = ( FINDCHILD ) GetProcAddress ( dll, "FindChild" );
	_FindSurface = ( FINDSURFACE ) GetProcAddress ( dll, "FindSurface" );
	_FitMesh = ( FITMESH ) GetProcAddress ( dll, "FitMesh" );
	_FlipMesh = ( FLIPMESH ) GetProcAddress ( dll, "FlipMesh" );
	_FreeBrush = ( FREEBRUSH ) GetProcAddress ( dll, "FreeBrush" );
	_FreeEntity = ( FREEENTITY ) GetProcAddress ( dll, "FreeEntity" );
	_FreeShadow = ( FREESHADOW ) GetProcAddress ( dll, "FreeShadow" );
	_FreeTexture = ( FREETEXTURE ) GetProcAddress ( dll, "FreeTexture" );
	_GetBrushTexture = ( GETBRUSHTEXTURE ) GetProcAddress ( dll, "GetBrushTexture" );
	_GetChild = ( GETCHILD ) GetProcAddress ( dll, "GetChild" );
	_GetEntityBrush = ( GETENTITYBRUSH ) GetProcAddress ( dll, "GetEntityBrush" );
	_GetEntityType = ( GETENTITYTYPE ) GetProcAddress ( dll, "GetEntityType" );
	_GetMatElement = ( GETMATELEMENT ) GetProcAddress ( dll, "GetMatElement" );
	_GetParentEntity = ( GETPARENTENTITY ) GetProcAddress ( dll, "GetParentEntity" );
	_GetSurface = ( GETSURFACE ) GetProcAddress ( dll, "GetSurface" );
	_GetSurfaceBrush = ( GETSURFACEBRUSH ) GetProcAddress ( dll, "GetSurfaceBrush" );
	_Graphics3D = ( GRAPHICS3D ) GetProcAddress ( dll, "Graphics3D" );
	_GraphicsResize = ( GRAPHICSRESIZE ) GetProcAddress ( dll, "GraphicsResize" );
	_HandleSprite = ( HANDLESPRITE ) GetProcAddress ( dll, "HandleSprite" );
	_HideEntity = ( HIDEENTITY ) GetProcAddress ( dll, "HideEntity" );
	_LightColor = ( LIGHTCOLOR ) GetProcAddress ( dll, "LightColor" );
	_LightConeAngles = ( LIGHTCONEANGLES ) GetProcAddress ( dll, "LightConeAngles" );
	_LightRange = ( LIGHTRANGE ) GetProcAddress ( dll, "LightRange" );
	_LinePick = ( LINEPICK ) GetProcAddress ( dll, "LinePick" );
	_LoadAnimMesh = ( LOADANIMMESH ) GetProcAddress ( dll, "LoadAnimMesh" );
	_LoadAnimTexture = ( LOADANIMTEXTURE ) GetProcAddress ( dll, "LoadAnimTexture" );
	_LoadBrush = ( LOADBRUSH ) GetProcAddress ( dll, "LoadBrush" );
	_LoadMesh = ( LOADMESH ) GetProcAddress ( dll, "LoadMesh" );
	_LoadTerrain = ( LOADTERRAIN ) GetProcAddress ( dll, "LoadTerrain" );
	_LoadTexture = ( LOADTEXTURE ) GetProcAddress ( dll, "LoadTexture" );
	_LoadSprite = ( LOADSPRITE ) GetProcAddress ( dll, "LoadSprite" );
	_MeshCSG = ( MESHCSG ) GetProcAddress ( dll, "MeshCSG" );
	_MeshDepth = ( MESHDEPTH ) GetProcAddress ( dll, "MeshDepth" );
	_MeshesIntersect = ( MESHESINTERSECT ) GetProcAddress ( dll, "MeshesIntersect" );
	_MeshHeight = ( MESHHEIGHT ) GetProcAddress ( dll, "MeshHeight" );
	_MeshWidth = ( MESHWIDTH ) GetProcAddress ( dll, "MeshWidth" );
	_ModifyTerrain = ( MODIFYTERRAIN ) GetProcAddress ( dll, "ModifyTerrain" );
	_MoveEntity = ( MOVEENTITY ) GetProcAddress ( dll, "MoveEntity" );
	_NameEntity = ( NAMEENTITY ) GetProcAddress ( dll, "NameEntity" );
	_PaintEntity = ( PAINTENTITY ) GetProcAddress ( dll, "PaintEntity" );
	_PaintMesh = ( PAINTMESH ) GetProcAddress ( dll, "PaintMesh" );
	_PaintSurface = ( PAINTSURFACE ) GetProcAddress ( dll, "PaintSurface" );
	_PickedEntity = ( PICKEDENTITY ) GetProcAddress ( dll, "PickedEntity" );
	_PickedNX = ( PICKEDNX ) GetProcAddress ( dll, "PickedNX" );
	_PickedNY = ( PICKEDNY ) GetProcAddress ( dll, "PickedNY" );
	_PickedNZ = ( PICKEDNZ ) GetProcAddress ( dll, "PickedNZ" );
	_PickedSurface = ( PICKEDSURFACE ) GetProcAddress ( dll, "PickedSurface" );
	_PickedTime = ( PICKEDTIME ) GetProcAddress ( dll, "PickedTime" );
	_PickedTriangle = ( PICKEDTRIANGLE ) GetProcAddress ( dll, "PickedTriangle" );
	_PickedX = ( PICKEDX ) GetProcAddress ( dll, "PickedX" );
	_PickedY = ( PICKEDY ) GetProcAddress ( dll, "PickedY" );
	_PickedZ = ( PICKEDZ ) GetProcAddress ( dll, "PickedZ" );
	_PointEntity = ( POINTENTITY ) GetProcAddress ( dll, "PointEntity" );
	_PositionEntity = ( POSITIONENTITY ) GetProcAddress ( dll, "PositionEntity" );
	_PositionMesh = ( POSITIONMESH ) GetProcAddress ( dll, "PositionMesh" );
	_PositionTexture = ( POSITIONTEXTURE ) GetProcAddress ( dll, "PositionTexture" );
	_ProjectedX = ( PROJECTEDX ) GetProcAddress ( dll, "ProjectedX" );
	_ProjectedY = ( PROJECTEDY ) GetProcAddress ( dll, "ProjectedY" );
	_ProjectedZ = ( PROJECTEDZ ) GetProcAddress ( dll, "ProjectedZ" );
	_RenderWorld = ( RENDERWORLD ) GetProcAddress ( dll, "RenderWorld" );
	_RepeatMesh = ( REPEATMESH ) GetProcAddress ( dll, "RepeatMesh" );
	_ResetEntity = ( RESETENTITY ) GetProcAddress ( dll, "ResetEntity" );
	_RotateEntity = ( ROTATEENTITY ) GetProcAddress ( dll, "RotateEntity" );
	_RotateMesh = ( ROTATEMESH ) GetProcAddress ( dll, "RotateMesh" );
	_RotateSprite = ( ROTATESPRITE ) GetProcAddress ( dll, "RotateSprite" );
	_RotateTexture = ( ROTATETEXTURE ) GetProcAddress ( dll, "RotateTexture" );
	_ScaleEntity = ( SCALEENTITY ) GetProcAddress ( dll, "ScaleEntity" );
	_ScaleMesh = ( SCALEMESH ) GetProcAddress ( dll, "ScaleMesh" );
	_ScaleSprite = ( SCALESPRITE ) GetProcAddress ( dll, "ScaleSprite" );
	_ScaleTexture = ( SCALETEXTURE ) GetProcAddress ( dll, "ScaleTexture" );
	_SetAnimTime = ( SETANIMTIME ) GetProcAddress ( dll, "SetAnimTime" );
	_SetCubeFace = ( SETCUBEFACE ) GetProcAddress ( dll, "SetCubeFace" );
	_SetCubeMode = ( SETCUBEMODE ) GetProcAddress ( dll, "SetCubeMode" );
	_ShowEntity = ( SHOWENTITY ) GetProcAddress ( dll, "ShowEntity" );
	_SpriteViewMode = ( SPRITEVIEWMODE ) GetProcAddress ( dll, "SpriteViewMode" );
	_StencilAlpha = ( STENCILALPHA ) GetProcAddress ( dll, "StencilAlpha" );
	_StencilClsColor = ( STENCILCLSCOLOR ) GetProcAddress ( dll, "StencilClsColor" );
	_StencilMesh = ( STENCILMESH ) GetProcAddress ( dll, "StencilMesh" );
	_StencilMode = ( STENCILMODE ) GetProcAddress ( dll, "StencilMode" );
	_TerrainHeight = ( TERRAINHEIGHT ) GetProcAddress ( dll, "TerrainHeight" );
	_TerrainX = ( TERRAINX ) GetProcAddress ( dll, "TerrainX" );
	_TerrainY = ( TERRAINY ) GetProcAddress ( dll, "TerrainY" );
	_TerrainZ = ( TERRAINZ ) GetProcAddress ( dll, "TerrainZ" );
	_TextureBlend = ( TEXTUREBLEND ) GetProcAddress ( dll, "TextureBlend" );
	_TextureCoords = ( TEXTURECOORDS ) GetProcAddress ( dll, "TextureCoords" );
	_TextureHeight = ( TEXTUREHEIGHT ) GetProcAddress ( dll, "TextureHeight" );
	_TextureFilter = ( TEXTUREFILTER ) GetProcAddress ( dll, "TextureFilter" );
	_TextureWidth = ( TEXTUREWIDTH ) GetProcAddress ( dll, "TextureWidth" );
	_TFormedX = ( TFORMEDX ) GetProcAddress ( dll, "TFormedX" );
	_TFormedY = ( TFORMEDY ) GetProcAddress ( dll, "TFormedY" );
	_TFormedZ = ( TFORMEDZ ) GetProcAddress ( dll, "TFormedZ" );
	_TFormNormal = ( TFORMNORMAL ) GetProcAddress ( dll, "TFormNormal" );
	_TFormPoint = ( TFORMPOINT ) GetProcAddress ( dll, "TFormPoint" );
	_TFormVector = ( TFORMVECTOR ) GetProcAddress ( dll, "TFormVector" );	
	_TranslateEntity = ( TRANSLATEENTITY ) GetProcAddress ( dll, "TranslateEntity" );
	_TriangleVertex = ( TRIANGLEVERTEX ) GetProcAddress ( dll, "TriangleVertex" );
	_TurnEntity = ( TURNENTITY ) GetProcAddress ( dll, "TurnEntity" );
	_UpdateNormals = ( UPDATENORMALS ) GetProcAddress ( dll, "UpdateNormals" );
	_UpdateTexCoords = ( UPDATETEXCOORDS ) GetProcAddress ( dll, "UpdateTexCoords" );
	_UpdateWorld = ( UPDATEWORLD ) GetProcAddress ( dll, "UpdateWorld" );
	_UseStencil = ( USESTENCIL ) GetProcAddress ( dll, "UseStencil" );
	_VectorPitch = ( VECTORPITCH ) GetProcAddress ( dll, "VectorPitch" );
	_VectorYaw = ( VECTORYAW ) GetProcAddress ( dll, "VectorYaw" );
	_VertexAlpha = ( VERTEXALPHA ) GetProcAddress ( dll, "VertexAlpha" );
	_VertexBlue = ( VERTEXBLUE ) GetProcAddress ( dll, "VertexBlue" );
	_VertexColor = ( VERTEXCOLOR ) GetProcAddress ( dll, "VertexColor" );
	_VertexCoords = ( VERTEXCOORDS ) GetProcAddress ( dll, "VertexCoords" );
	_VertexGreen = ( VERTEXGREEN ) GetProcAddress ( dll, "VertexGreen" );
	_VertexNormal = ( VERTEXNORMAL ) GetProcAddress ( dll, "VertexNormal" );
	_VertexNX = ( VERTEXNX ) GetProcAddress ( dll, "VertexNX" );
	_VertexNY = ( VERTEXNY ) GetProcAddress ( dll, "VertexNY" );
	_VertexNZ = ( VERTEXNZ ) GetProcAddress ( dll, "VertexNZ" );
	_VertexRed = ( VERTEXRED ) GetProcAddress ( dll, "VertexRed" );
	_VertexTexCoords = ( VERTEXTEXCOORDS ) GetProcAddress ( dll, "VertexTexCoords" );
	_VertexU = ( VERTEXU ) GetProcAddress ( dll, "VertexU" );
	_VertexV = ( VERTEXV ) GetProcAddress ( dll, "VertexV" );
	_VertexW = ( VERTEXW ) GetProcAddress ( dll, "VertexW" );
	_VertexX = ( VERTEXX ) GetProcAddress ( dll, "VertexX" );
	_VertexY = ( VERTEXY ) GetProcAddress ( dll, "VertexY" );
	_VertexZ = ( VERTEXZ ) GetProcAddress ( dll, "VertexZ" );
	_VoxelSpriteMaterial = ( VOXELSPRITEMATERIAL ) GetProcAddress ( dll, "VoxelSpriteMaterial" );
	_Wireframe = ( WIREFRAME ) GetProcAddress ( dll, "Wireframe" );
	_EntityScaleX = ( ENTITYSCALEX ) GetProcAddress ( dll, "EntityScaleX" );
	_EntityScaleY = ( ENTITYSCALEY ) GetProcAddress ( dll, "EntityScaleY" );
	_EntityScaleZ = ( ENTITYSCALEZ ) GetProcAddress ( dll, "EntityScaleZ" );
	_LoadShader = ( LOADSHADER ) GetProcAddress ( dll, "LoadShader" );
	_CreateShader = ( CREATESHADER ) GetProcAddress ( dll, "CreateShader" );
	_ShadeSurface = ( SHADESURFACE ) GetProcAddress ( dll, "ShadeSurface" );
	_ShadeMesh = ( SHADEMESH ) GetProcAddress ( dll, "ShadeMesh" );
	_ShadeEntity = ( SHADEENTITY ) GetProcAddress ( dll, "ShadeEntity" );
	_ShaderTexture = ( SHADERTEXTURE ) GetProcAddress ( dll, "ShaderTexture" );
	_SetFloat = ( SETFLOAT ) GetProcAddress ( dll, "SetFloat" );
	_SetFloat2 = ( SETFLOAT2 ) GetProcAddress ( dll, "SetFloat2" );
	_SetFloat3 = ( SETFLOAT3 ) GetProcAddress ( dll, "SetFloat3" );
	_SetFloat4 = ( SETFLOAT4 ) GetProcAddress ( dll, "SetFloat4" );
	_UseFloat = ( USEFLOAT ) GetProcAddress ( dll, "UseFloat" );
	_UseFloat2 = ( USEFLOAT2 ) GetProcAddress ( dll, "UseFloat2" );
	_UseFloat3 = ( USEFLOAT3 ) GetProcAddress ( dll, "UseFloat3" );
	_UseFloat4 = ( USEFLOAT4 ) GetProcAddress ( dll, "UseFloat4" );
	_SetInteger = ( SETINTEGER ) GetProcAddress ( dll, "SetInteger" );
	_SetInteger2 = ( SETINTEGER2 ) GetProcAddress ( dll, "SetInteger2" );
	_SetInteger3 = ( SETINTEGER3 ) GetProcAddress ( dll, "SetInteger3" );
	_SetInteger4 = ( SETINTEGER4 ) GetProcAddress ( dll, "SetInteger4" );
	_UseInteger = ( USEINTEGER ) GetProcAddress ( dll, "UseInteger" );
	_UseInteger2 = ( USEINTEGER2 ) GetProcAddress ( dll, "UseInteger2" );
	_UseInteger3 = ( USEINTEGER3 ) GetProcAddress ( dll, "UseInteger3" );
	_UseInteger4 = ( USEINTEGER4 ) GetProcAddress ( dll, "UseInteger4" );
	_UseSurface = ( USESURFACE ) GetProcAddress ( dll, "UseSurface" );
	_UseMatrix = ( USEMATRIX ) GetProcAddress ( dll, "UseMatrix" );
	_LoadMaterial = ( LOADMATERIAL ) GetProcAddress ( dll, "LoadMaterial" );
	_ShaderMaterial = ( SHADERMATERIAL ) GetProcAddress ( dll, "ShaderMaterial" );
	_CreateOcTree = ( CREATEOCTREE ) GetProcAddress ( dll, "CreateOcTree" );
	_AddToOctree = ( ADDTOOCTREE ) GetProcAddress ( dll, "AddToOctree" );
	//These should really be checked to see if they are initiaised properly...
	// we now have a context and the function mapped so call "Graphics3D" with our args to start the engine....

	int width;
	int height;
	// set defaults
	int mode = 0;
	int depth = 0;
	int rate = 60;

	// get rest of compusolry args from LC...
	// "%d" reads an int
	//"%f" reads a float
	//"%p" reads a pointer address

	LC_READARG ( width, 1, "%d" );
	LC_READARG ( height, 2, "%d" );

	// read our optional arguemnts if they exist...
	if (p_argument_count >= 4)
	{
		LC_READARG ( mode, 3, "%d" );
	}
	if (p_argument_count >= 5)
	{
		LC_READARG ( depth, 4, "%d" );
	}
	if (p_argument_count >= 6)
	{
		LC_READARG ( rate, 5, "%d" );
	}

	// call our function pointer with the args
	_Graphics3D( width, height ,depth, mode, rate );
	// its a LC command so return void
	LC_RETURN_VOID;
}



LC_ENTRY ( BufferToTex ) 
{
	LC_ARG_COUNT ( 3 );
	char* tex;
	unsigned char* buffer;
	int frame;
	LC_READARG ( tex, 0, "%p" );
	LC_READARG ( buffer, 1, "%p" );
	LC_READARG ( frame, 2, "%d" );
	_BufferToTex ( tex, buffer, frame);
	LC_RETURN_VOID;
}

LC_ENTRY ( BackBufferToTex ) 
{
	LC_ARG_COUNT ( 2 );
	char* tex;
	int frame;
	LC_READARG ( tex, 0, "%p" );
	LC_READARG ( frame, 1, "%d" );
	_BackBufferToTex ( tex, frame);
	LC_RETURN_VOID;
}

LC_ENTRY ( TexToBuffer ) 
{
	LC_ARG_COUNT ( 3 );
	char* tex = NULL;
	unsigned char* buffer = NULL;
	int frame;
	LC_READARG ( tex, 0, "%p" );
	LC_READARG ( buffer, 1, "%p" );
	LC_READARG ( frame, 2, "%d" );
	_TexToBuffer ( tex, buffer, frame);
	LC_RETURN_VOID;
}

LC_ENTRY ( MeshCullRadius ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent = NULL;
	float radius;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( radius, 1, "%f" );
	_MeshCullRadius ( ent, radius);
	LC_RETURN_VOID;
}

LC_ENTRY ( AddAnimSeq ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent = NULL;
	int length;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( length, 1, "%d" );
	int result;
	result = _AddAnimSeq ( ent, length);
	LC_RETURN_INT;
}

LC_ENTRY ( AddMesh ) 
{
	LC_ARG_COUNT ( 2 );
	char* mesh1 = NULL;
	char* mesh2 = NULL;
	LC_READARG ( mesh1, 0, "%p" );
	LC_READARG ( mesh2, 1, "%p" );
	_AddMesh ( mesh1, mesh2);
	LC_RETURN_VOID;
}

LC_ENTRY ( AddTriangle ) 
{
	LC_ARG_COUNT ( 4 );
	char* surf = NULL;
	int v0;
	int v1;
	int v2;
	LC_READARG ( surf, 0, "%p" );
	LC_READARG ( v0, 1, "%d" );
	LC_READARG ( v1, 2, "%d" );
	LC_READARG ( v2, 3, "%d" );
	int result;
	result = _AddTriangle ( surf, v0, v1, v2);
	LC_RETURN_INT;
}

LC_ENTRY ( AddVertex ) 
{
	LC_ARG_COUNT ( 4 );
	char* surf = NULL;
	float x;
	float y;
	float z;
	float u = 0;
	float v = 0;
	float w = 0;
	LC_READARG ( surf, 0, "%p" );
	LC_READARG ( x, 1, "%f" );
	LC_READARG ( y, 2, "%f" );
	LC_READARG ( z, 3, "%f" );
	if (p_argument_count >= 4 ){ LC_READARG ( z, 3, "%f" );}
	if (p_argument_count >= 5 ){ LC_READARG ( u, 4, "%f" );}
	if (p_argument_count >= 6 ){ LC_READARG ( v, 5, "%f" );}
	if (p_argument_count >= 7 ){ LC_READARG ( w, 6, "%f" );}
	int result;
	result = _AddVertex ( surf, x, y, z, u, v, w);
	LC_RETURN_INT;
}

LC_ENTRY ( AmbientLight ) 
{
	LC_ARG_COUNT ( 3 );
	float r;
	float g;
	float b;
	LC_READARG ( r, 0, "%f" );
	LC_READARG ( g, 1, "%f" );
	LC_READARG ( b, 2, "%f" );
	_AmbientLight ( r, g, b);
	LC_RETURN_VOID;
}

LC_ENTRY ( AntiAlias ) 
{
	LC_ARG_COUNT ( 1 );
	int samples;
	LC_READARG ( samples, 0, "%d" );
	_AntiAlias ( samples);
	LC_RETURN_VOID;
}

LC_ENTRY ( Animate ) 
{
	LC_ARG_COUNT ( 1 );
	char* ent = NULL;
	int mode = 1;
	float speed = 1;
	int seq = 0;
	int trans = 0;
	LC_READARG ( ent, 0, "%p" );
	if (p_argument_count >= 2 ){ LC_READARG ( mode, 1, "%d" );}
	if (p_argument_count >= 3 ){ LC_READARG ( speed, 2, "%f" );}
	if (p_argument_count >= 4 ){ LC_READARG ( seq, 3, "%d" );}
	if (p_argument_count >= 5 ){ LC_READARG ( trans, 4, "%d" );}
	_Animate ( ent, mode, speed, seq, trans);
	LC_RETURN_VOID;
}

LC_ENTRY ( Animating ) 
{
	LC_ARG_COUNT ( 1 );
	char* ent = NULL;
	LC_READARG ( ent, 0, "%p" );
	int result;
	result = _Animating ( ent);
	LC_RETURN_INT;
}

LC_ENTRY ( AnimLength ) 
{
	LC_ARG_COUNT ( 1 );
	char* ent = NULL;
	LC_READARG ( ent, 0, "%p" );
	int result;
	result = _AnimLength ( ent );
	LC_RETURN_INT;
}

LC_ENTRY ( AnimSeq ) 
{
	LC_ARG_COUNT ( 1 );
	char* ent = NULL;
	LC_READARG ( ent, 0, "%p" );
	int result;
	result = _AnimSeq ( ent );
	LC_RETURN_INT;
}

LC_ENTRY ( AnimTime ) 
{
	LC_ARG_COUNT ( 1 );
	char* ent = NULL;
	LC_READARG ( ent, 0, "%p" );
	float result;
	result = _AnimTime ( ent );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( BrushAlpha ) 
{
	LC_ARG_COUNT ( 2 );
	char* brush = NULL;
	float a;
	LC_READARG ( brush, 0, "%p" );
	LC_READARG ( a, 1, "%f" );
	_BrushAlpha ( brush, a );
	LC_RETURN_VOID;
}

LC_ENTRY ( BrushBlend ) 
{
	LC_ARG_COUNT ( 1 );
	char* brush = NULL;
	int blend = 1;
	LC_READARG ( brush, 0, "%p" );
	if (p_argument_count >= 2){ LC_READARG ( blend, 1, "%d" );}
	_BrushBlend ( brush, blend);
	LC_RETURN_VOID;
}

LC_ENTRY ( BrushColor ) 
{
	LC_ARG_COUNT ( 1 );
	char* brush = NULL;
	float r = 255.0;
	float g = 255.0;
	float b  = 255.0;
	LC_READARG ( brush, 0, "%p" );
	if (p_argument_count >= 2){	LC_READARG ( r, 1, "%f" );}
	if (p_argument_count >=3){ LC_READARG ( g, 2, "%f" );}
	if (p_argument_count >= 4){ LC_READARG ( b, 3, "%f" );}
	_BrushColor ( brush, r, g, b);
	LC_RETURN_VOID;
}

LC_ENTRY ( BrushFX ) 
{
	LC_ARG_COUNT ( 1 );
	char* brush = NULL;
	int fx = 0;
	LC_READARG ( brush, 0, "%p" );
	if (p_argument_count >= 2){ LC_READARG ( fx, 1, "%d" );}
	_BrushFX ( brush, fx);
	LC_RETURN_VOID;
}

LC_ENTRY ( BrushShininess ) 
{
	LC_ARG_COUNT ( 2 );
	char* brush = NULL;
	float s;
	LC_READARG ( brush, 0, "%p" );
	LC_READARG ( s, 1, "%f" );
	_BrushShininess ( brush, s);
	LC_RETURN_VOID;
}

LC_ENTRY ( BrushTexture ) 
{
	LC_ARG_COUNT ( 2 );
	char* brush = NULL;
	char* tex = NULL;
	int frame = 0;
	int index = 0;
	LC_READARG ( brush, 0, "%p" );
	LC_READARG ( tex, 1, "%p" );
	if (p_argument_count >= 3){ LC_READARG ( frame, 2, "%d" );}
	if (p_argument_count >= 4){	LC_READARG ( index, 3, "%d" );}
	_BrushTexture ( brush, tex, frame, index);
	LC_RETURN_VOID;
}

LC_ENTRY ( CameraClsColor ) 
{
	LC_ARG_COUNT ( 1 );
	char* cam = NULL;
	float r = 0;
	float g = 0;
	float b = 0;
	LC_READARG ( cam, 0, "%p" );
	if (p_argument_count >= 2 ){ LC_READARG ( r, 1, "%f" );}
	if (p_argument_count >= 3 ){ LC_READARG ( g, 2, "%f" );}
	if (p_argument_count >= 4 ){ LC_READARG ( b, 3, "%f" );}
	_CameraClsColor ( cam, r, g, b);
	LC_RETURN_VOID;
}

LC_ENTRY ( CameraClsMode ) 
{
	LC_ARG_COUNT ( 3 );
	char* cam = NULL;
	int cls_depth;
	int cls_zbuffer;
	LC_READARG ( cam, 0, "%p" );
	LC_READARG ( cls_depth, 1, "%d" );
	LC_READARG ( cls_zbuffer, 2, "%d" );
	_CameraClsMode ( cam, cls_depth, cls_zbuffer);
	LC_RETURN_VOID;
}

LC_ENTRY ( CameraFogColor ) 
{
	LC_ARG_COUNT ( 4 );
	char* cam = NULL;
	float r;
	float g;
	float b;
	LC_READARG ( cam, 0, "%p" );
	LC_READARG ( r, 1, "%f" );
	LC_READARG ( g, 2, "%f" );
	LC_READARG ( b, 3, "%f" );
	_CameraFogColor ( cam, r, g, b );
	LC_RETURN_VOID;
}

LC_ENTRY ( CameraFogMode ) 
{
	LC_ARG_COUNT ( 1 );
	char* cam = NULL;
	int mode=0;
	LC_READARG ( cam, 0, "%p" );
	if (p_argument_count >= 2 ){ LC_READARG ( mode, 1, "%d" );}
	_CameraFogMode ( cam, mode);
	LC_RETURN_VOID;
}

LC_ENTRY ( CameraFogRange ) 
{
	LC_ARG_COUNT ( 3 );
	char* cam = NULL;
	float nnear;
	float nfar;
	LC_READARG ( cam, 0, "%p" );
	LC_READARG ( nnear, 1, "%f" );
	LC_READARG ( nfar, 2, "%f" );
	_CameraFogRange ( cam, nnear, nfar);
	LC_RETURN_VOID;
}

LC_ENTRY ( CameraPick ) 
{
	LC_ARG_COUNT ( 3 );
	char* cam = NULL;
	float x;
	float y;
	LC_READARG ( cam, 0, "%p" );
	LC_READARG ( x, 1, "%f" );
	LC_READARG ( y, 2, "%f" );
	char* result = NULL;
	result = _CameraPick ( cam, x, y );
	LC_RETURN_POINTER;
}

LC_ENTRY ( CameraProject ) 
{
	LC_ARG_COUNT ( 4 );
	char* cam = NULL;
	float x;
	float y;
	float z;
	LC_READARG ( cam, 0, "%p" );
	LC_READARG ( x, 1, "%f" );
	LC_READARG ( y, 2, "%f" );
	LC_READARG ( z, 3, "%f" );
	_CameraProject ( cam, x, y, z);
	LC_RETURN_VOID;
}

LC_ENTRY ( CameraProjMode ) 
{
	LC_ARG_COUNT ( 1 );
	char* cam = NULL;
	int mode = 1;
	LC_READARG ( cam, 0, "%p" );
	if (p_argument_count >= 2 ){ LC_READARG ( mode, 1, "%d" );}
	_CameraProjMode ( cam, mode );
	LC_RETURN_VOID;
}

LC_ENTRY ( CameraRange ) 
{
	LC_ARG_COUNT ( 1 );
	char* cam = NULL;
	float nnear = 1.0;
	float nfar = 1000.0;
	LC_READARG ( cam, 0, "%p" );
	if (p_argument_count >= 2 ){ LC_READARG ( nnear, 1, "%f" );}
	if (p_argument_count >= 3 ){ LC_READARG ( nfar, 2, "%f" );}
	_CameraRange ( cam, nnear, nfar );
	LC_RETURN_VOID;
}

LC_ENTRY ( CameraViewport ) 
{
	LC_ARG_COUNT ( 5 );
	char* cam = NULL;
	int x;
	int y;
	int width;
	int height;
	LC_READARG ( cam, 0, "%p" );
	LC_READARG ( x, 1, "%d" );
	LC_READARG ( y, 2, "%d" );
	LC_READARG ( width, 3, "%d" );
	LC_READARG ( height, 4, "%d" );
	_CameraViewport ( cam, x, y, width, height );
	LC_RETURN_VOID;
}

LC_ENTRY ( CameraZoom ) 
{
	LC_ARG_COUNT ( 1 );
	char* cam = NULL;
	float zoom = 1;
	LC_READARG ( cam, 0, "%p" );
	if (p_argument_count >= 2 ){ LC_READARG ( zoom, 1, "%f" );}
	_CameraZoom ( cam, zoom );
	LC_RETURN_VOID;
}

LC_ENTRY ( ClearCollisions ) 
{
	_ClearCollisions ( );
	LC_RETURN_VOID;
}

LC_ENTRY ( ClearSurface ) 
{
	LC_ARG_COUNT ( 1 );
	char* surf = NULL;
	bool clear_verts = 1;
	bool clear_tris = 1;
	LC_READARG ( surf, 0, "%p" );
	if (p_argument_count >= 2 ){ LC_READARG ( clear_verts, 1, "%d" );}
	if (p_argument_count >= 3 ){ LC_READARG ( clear_tris, 2, "%d" );}
	_ClearSurface ( surf, clear_verts, clear_tris );
	LC_RETURN_VOID;
}

LC_ENTRY ( ClearTextureFilters ) 
{
	_ClearTextureFilters ( );
	LC_RETURN_VOID;
}

LC_ENTRY ( ClearWorld ) 
{
	bool entities = 1;
	bool brushes = 1;
	bool textures = 1;
	if (p_argument_count >= 1 ){ LC_READARG ( entities, 0, "%d" );}
	if (p_argument_count >= 2 ){ LC_READARG ( brushes, 1, "%d" );}
	if (p_argument_count >= 3 ){ LC_READARG ( textures, 2, "%d" );}
	_ClearWorld ( entities, brushes, textures );
	LC_RETURN_VOID;
}

LC_ENTRY ( CollisionEntity ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent = NULL;
	int index;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( index, 1, "%d" );
	char* result = NULL;
	result = _CollisionEntity ( ent, index );
	LC_RETURN_POINTER;
}

LC_ENTRY ( Collisions ) 
{
	LC_ARG_COUNT ( 4 );
	int src_no;
	int dest_no;
	int method_no;
	int response_no;
	LC_READARG ( src_no, 0, "%d" );
	LC_READARG ( dest_no, 1, "%d" );
	LC_READARG ( method_no, 2, "%d" );
	LC_READARG ( response_no, 3, "%d" );
	_Collisions ( src_no, dest_no, method_no, response_no );
	LC_RETURN_VOID;
}

LC_ENTRY ( CollisionNX ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent = NULL;
	int index;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( index, 1, "%d" );
	float result;
	result = _CollisionNX ( ent, index );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( CollisionNY ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent = NULL;
	int index;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( index, 1, "%d" );
	float result;
	result = _CollisionNY ( ent, index );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( CollisionNZ ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent = NULL;
	int index;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( index, 1, "%d" );
	float result;
	result = _CollisionNZ ( ent, index );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( CollisionSurface ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent = NULL;
	int index;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( index, 1, "%d" );
	char* result = NULL;
	result = _CollisionSurface ( ent, index );
	LC_RETURN_POINTER;
}

LC_ENTRY ( CollisionTime ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent = NULL;
	int index;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( index, 1, "%d" );
	float result;
	result = _CollisionTime ( ent, index);
	LC_RETURN_FLOAT;
}

LC_ENTRY ( CollisionTriangle ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent = NULL;
	int index;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( index, 1, "%d" );
	int result;
	result = _CollisionTriangle ( ent, index );
	LC_RETURN_INT;
}

LC_ENTRY ( CollisionX ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent = NULL;
	int index;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( index, 1, "%d" );
	float result;
	result = _CollisionX ( ent, index );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( CollisionY ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent = NULL;
	int index;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( index, 1, "%d" );
	float result;
	result = _CollisionY ( ent, index );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( CollisionZ ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent = NULL;
	int index;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( index, 1, "%d" );
	float result;
	result = _CollisionZ ( ent, index );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( CountChildren ) 
{
	LC_ARG_COUNT ( 1 );
	char* ent = NULL;
	LC_READARG ( ent, 0, "%p" );
	int result;
	result = _CountChildren ( ent );
	LC_RETURN_INT;
}

LC_ENTRY ( CountCollisions ) 
{
	LC_ARG_COUNT ( 1 );
	char* ent = NULL;
	LC_READARG ( ent, 0, "%p" );
	int result;
	result = _CountCollisions ( ent );
	LC_RETURN_INT;
}

LC_ENTRY ( CopyEntity ) 
{
	LC_ARG_COUNT ( 1 );
	char* ent = NULL;
	char* parent = NULL;
	LC_READARG ( ent, 0, "%p" );
	if (p_argument_count >= 2 ){ LC_READARG ( parent, 1, "%p" );}
	char* result = NULL;
	result = _CopyEntity ( ent, parent );
	LC_RETURN_POINTER;
}

LC_ENTRY ( CopyMesh ) 
{
	LC_ARG_COUNT ( 1 );
	char* mesh = NULL;
	char* parent=NULL;
	LC_READARG ( mesh, 0, "%p" );
	if (p_argument_count >= 2 ){ LC_READARG ( parent, 1, "%p" );}
	char* result = NULL;
	result = _CopyMesh ( mesh, parent );
	LC_RETURN_POINTER;
}

LC_ENTRY ( CountSurfaces ) 
{
	LC_ARG_COUNT ( 1 );
	char* mesh = NULL;
	LC_READARG ( mesh, 0, "%p" );
	int result;
	result = _CountSurfaces ( mesh );
	LC_RETURN_INT;
}

LC_ENTRY ( CountTriangles ) 
{
	LC_ARG_COUNT ( 1 );
	char* surf = NULL;
	LC_READARG ( surf, 0, "%p" );
	int result;
	result = _CountTriangles ( surf );
	LC_RETURN_INT;
}

LC_ENTRY ( CountVertices ) 
{
	LC_ARG_COUNT ( 1 );
	char* surf = NULL;
	LC_READARG ( surf, 0, "%p" );
	int result;
	result = _CountVertices ( surf);
	LC_RETURN_INT;
}

LC_ENTRY ( CreateBrush ) 
{
	float r = 255.0;
	float g = 255.0;
	float b = 255.0;
	if (p_argument_count >= 1 ){ LC_READARG ( r, 0, "%f" );}
	if (p_argument_count >= 2 ){ LC_READARG ( g, 1, "%f" );}
	if (p_argument_count >= 3 ){ LC_READARG ( b, 2, "%f" );}
	char* result = NULL;
	result = _CreateBrush ( r, g, b );
	LC_RETURN_POINTER;
}

LC_ENTRY ( CreateCamera ) 
{
	char* parent = NULL;
	if (p_argument_count >= 1 ){ LC_READARG ( parent, 0, "%p" );}
	char* result = NULL;
	result = _CreateCamera ( parent );
	LC_RETURN_POINTER;
}

LC_ENTRY ( CreateCone ) 
{
	int segments = 8;
	bool solid = 1;
	char* parent = NULL;
	if (p_argument_count >= 1){ LC_READARG ( segments, 0, "%d" );}
	if (p_argument_count >= 2){ LC_READARG ( solid, 1, "%d" );}
	if (p_argument_count >= 1){ LC_READARG ( parent, 2, "%p" );}
	char* result = NULL;
	result = _CreateCone ( segments, solid, parent );
	LC_RETURN_POINTER;
}

LC_ENTRY ( CreateCylinder ) 
{
	int segments = 8;
	bool solid = 1;
	char* parent = NULL;
	if (p_argument_count >= 1){ LC_READARG ( segments, 0, "%d" );}
	if (p_argument_count >= 2){ LC_READARG ( solid, 1, "%d" );}
	if (p_argument_count >= 1){ LC_READARG ( parent, 2, "%p" );}
	char* result = NULL;
	result = _CreateCylinder ( segments, solid, parent );
	LC_RETURN_POINTER;
}

LC_ENTRY ( CreateCube ) 
{
	char* parent = NULL;
	if (p_argument_count >= 1){ LC_READARG ( parent, 0, "%p" );}
	char* result = NULL;
	result = _CreateCube ( parent );
	LC_RETURN_POINTER;
}

LC_ENTRY ( CreateMesh ) 
{
	char* parent = NULL;
	if (p_argument_count >= 1){ LC_READARG ( parent, 0, "%p" );}
	char* result = NULL;
	result = _CreateMesh ( parent );
	LC_RETURN_POINTER;
}

LC_ENTRY ( CreateLight ) 
{
	int light_type = 1;
	char* parent = NULL;
	if (p_argument_count >= 1){ LC_READARG ( light_type, 0, "%d" );}
	if (p_argument_count >= 2){	LC_READARG ( parent, 1, "%p" );}
	char* result = NULL;
	result = _CreateLight ( light_type, parent );
	LC_RETURN_POINTER;
}

LC_ENTRY ( CreatePivot ) 
{
	char* parent = NULL;
	if (p_argument_count >= 1){ LC_READARG ( parent, 0, "%p" );}
	char* result = NULL;
	result = _CreatePivot ( parent );
	LC_RETURN_POINTER;
}

LC_ENTRY ( CreatePlane ) 
{
	int divisions = 1;
	char* parent = NULL;
	if (p_argument_count >= 1){ LC_READARG ( divisions, 0, "%d" );}
	if (p_argument_count >= 2){ LC_READARG ( parent, 1, "%p" );}
	char* result = NULL;
	result = _CreatePlane ( divisions, parent );
	LC_RETURN_POINTER;
}

LC_ENTRY ( CreateShadow ) 
{
	LC_ARG_COUNT ( 1 );
	char* parent = NULL;
	int Static = 0;
	LC_READARG ( parent, 0, "%p" );
	if (p_argument_count >= 2){ LC_READARG ( Static, 1, "%d");}
	char* result = NULL;
	result = _CreateShadow ( parent, Static );
	LC_RETURN_POINTER;
}

LC_ENTRY ( CreateSphere ) 
{
	int segments = 8;
	char* parent = NULL;
	if (p_argument_count >= 1){ LC_READARG ( segments, 0, "%d" );}
	if (p_argument_count >= 2){ LC_READARG ( parent, 1, "%p" );}
	char* result = NULL;
	result = _CreateSphere ( segments, parent );
	LC_RETURN_POINTER;
}

LC_ENTRY ( CreateSprite ) 
{
	char* parent = NULL;
	if (p_argument_count >= 1){ LC_READARG ( parent, 0, "%p" );}
	char* result = NULL;
	result = _CreateSprite ( parent );
	LC_RETURN_POINTER;
}

LC_ENTRY ( CreateSurface ) 
{
	LC_ARG_COUNT ( 1 );
	char* mesh = NULL;
	char* brush = NULL;
	LC_READARG ( mesh, 0, "%p" );
	if (p_argument_count >= 2){ LC_READARG ( brush, 1, "%p" );}
	char* result = NULL;
	result = _CreateSurface ( mesh, brush );
	LC_RETURN_POINTER;
}

LC_ENTRY ( CreateStencil ) 
{
	char* result = NULL;
	result = _CreateStencil ( );
	LC_RETURN_POINTER;
}

LC_ENTRY ( CreateTerrain ) 
{
	LC_ARG_COUNT ( 1 );
	int size;
	char* parent = NULL;
	LC_READARG ( size, 0, "%d" );
	if (p_argument_count >= 2){ LC_READARG ( parent, 1, "%p" );}
	char* result = NULL;
	result = _CreateTerrain ( size, parent );
	LC_RETURN_POINTER;
}

LC_ENTRY ( CreateTexture ) 
{
	LC_ARG_COUNT ( 2 );
	int width;
	int height;
	int flags = 1;
	int frames = 1;
	LC_READARG ( width, 0, "%d" );
	LC_READARG ( height, 1, "%d" );
	if (p_argument_count >= 3){ LC_READARG ( flags, 2, "%d" );}
	if (p_argument_count >= 4){ LC_READARG ( frames, 3, "%d" );}
	char* result = NULL;
	result = _CreateTexture ( width, height, flags, frames );
	LC_RETURN_POINTER;
}

LC_ENTRY ( CreateVoxelSprite ) 
{
	LC_ARG_COUNT ( 2 );
	int slices;
	char* parent;
	LC_READARG ( slices, 0, "%d" );
	LC_READARG ( parent, 1, "%p" );
	char* result = NULL;
	result = _CreateVoxelSprite ( slices, parent );
	LC_RETURN_POINTER;
}

LC_ENTRY ( DeltaPitch ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent1 = NULL;
	char* ent2 = NULL;
	LC_READARG ( ent1, 0, "%p" );
	LC_READARG ( ent2, 1, "%p" );
	float result;
	result = _DeltaPitch ( ent1, ent2 );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( DeltaYaw ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent1 = NULL;
	char* ent2 = NULL;
	LC_READARG ( ent1, 0, "%p" );
	LC_READARG ( ent2, 1, "%p" );
	float result;
	result = _DeltaYaw ( ent1, ent2 );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( EntityAlpha ) 
{
	LC_ARG_COUNT ( 2 );
	 char* ent = NULL;
	 float alpha;
	 LC_READARG ( ent, 0, "%p" );
	 LC_READARG ( alpha, 1, "%f" );
	 _EntityAlpha ( ent, alpha);
	 LC_RETURN_VOID;
}

LC_ENTRY ( EntityAutoFade ) 
{
	LC_ARG_COUNT ( 3 );
	char* ent = NULL;
	float nnear;
	float nfar;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( nnear, 1, "%f" );
	LC_READARG ( nfar, 2, "%f" );
	_EntityAutoFade ( ent, nnear, nfar );
	LC_RETURN_VOID;
}

LC_ENTRY ( EntityBlend ) 
{
	LC_ARG_COUNT ( 1 );
	char* ent = NULL;
	int blend = 1;
	LC_READARG ( ent, 0, "%p" );
	if (p_argument_count >= 2){ LC_READARG ( blend, 1, "%d" );}
	_EntityBlend ( ent, blend );
	LC_RETURN_VOID;
}

LC_ENTRY ( EntityBox ) 
{
	LC_ARG_COUNT ( 7 );
	char* ent = NULL;
	float x;
	float y;
	float z;
	float w;
	float h;
	float d;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( x, 1, "%f" );
	LC_READARG ( y, 2, "%f" );
	LC_READARG ( z, 3, "%f" );
	LC_READARG ( w, 4, "%f" );
	LC_READARG ( h, 5, "%f" );
	LC_READARG ( d, 6, "%f" );
	_EntityBox ( ent, x, y, z, w, h, d );
	LC_RETURN_VOID;
}

LC_ENTRY ( EntityCollided ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent = NULL;
	int type_no;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( type_no, 1, "%d" );
	char* result = NULL;
	result = _EntityCollided ( ent, type_no );
	LC_RETURN_POINTER;
}

LC_ENTRY ( EntityColor ) 
{
	LC_ARG_COUNT ( 1 );
	char* ent = NULL;
	float red = 255.0;
	float green = 255.0;
	float blue = 255.0;
	LC_READARG ( ent, 0, "%p" );
	if (p_argument_count >= 2){ LC_READARG ( red, 1, "%f" );}
	if (p_argument_count >= 3){ LC_READARG ( green, 2, "%f" );}
	if (p_argument_count >= 4){ LC_READARG ( blue, 3, "%f" );}
	_EntityColor ( ent, red, green, blue );
	LC_RETURN_VOID;
}

LC_ENTRY ( EntityDistance ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent1 = NULL;
	char* ent2 = NULL;
	LC_READARG ( ent1, 0, "%p" );
	LC_READARG ( ent2, 1, "%p" );
	float result;
	result = _EntityDistance ( ent1, ent2 );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( EntityFX ) 
{
	LC_ARG_COUNT ( 1 );
	char* ent = NULL;
	int fx = 0;
	LC_READARG ( ent, 0, "%p" );
	if (p_argument_count >= 2){ LC_READARG ( fx, 1, "%d" );}
	_EntityFX ( ent, fx );
	LC_RETURN_VOID;
}

LC_ENTRY ( EntityInView ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent = NULL;
	char* cam = NULL;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( cam, 1, "%p" );
	int result;
	result = _EntityInView ( ent, cam );
	LC_RETURN_INT;
}

LC_ENTRY ( EntityOrder ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent = NULL;
	int order;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( order, 1, "%d" );
	_EntityOrder ( ent, order );
	LC_RETURN_VOID;
}

LC_ENTRY ( EntityParent ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent = NULL;
	char* parent_ent = NULL;
	bool glob = 1;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( parent_ent, 1, "%p" );
	if (p_argument_count >= 3){ LC_READARG ( glob, 2, "%d" );}
	_EntityParent ( ent, parent_ent, glob );
	LC_RETURN_VOID;
}

LC_ENTRY ( EntityPick ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent = NULL;
	float range;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( range, 1, "%f" );
	char* result = NULL;
	result = _EntityPick ( ent, range );
	LC_RETURN_POINTER;
}

LC_ENTRY ( EntityPickMode ) 
{
	LC_ARG_COUNT ( 1 );
	char* ent = NULL;
	int pick_mode = 0;
	bool obscurer = 1;
	LC_READARG ( ent, 0, "%p" );
	if (p_argument_count >= 2){ LC_READARG ( pick_mode, 1, "%d" );}
	if (p_argument_count >= 3){ LC_READARG ( obscurer, 2, "%d" );}
	_EntityPickMode ( ent, pick_mode, obscurer );
	LC_RETURN_VOID;
}

LC_ENTRY ( EntityPitch ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent = NULL;
	bool glob;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( glob, 1, "%d" );
	float result;
	result = _EntityPitch ( ent, glob );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( EntityRadius ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent = NULL;
	float radius_x;
	float radius_y;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( radius_x, 1, "%f" );
	radius_y = radius_x;
	if (p_argument_count >= 3){ LC_READARG ( radius_y, 2, "%f" );}
	_EntityRadius ( ent, radius_x, radius_y);
	LC_RETURN_VOID;
}

LC_ENTRY ( EntityRoll ) 
{
	LC_ARG_COUNT ( 1 );
	char* ent = NULL;
	bool glob = 0;
	LC_READARG ( ent, 0, "%p" );
	if (p_argument_count >= 2){ LC_READARG ( glob, 1, "%d" );}
	float result;
	result = _EntityRoll ( ent, glob );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( EntityShininess ) 
{
	LC_ARG_COUNT ( 1 );
	char* ent = NULL;
	float shine = 0;
	LC_READARG ( ent, 0, "%p" );
	if (p_argument_count >= 2){ LC_READARG ( shine, 1, "%f" );}
	_EntityShininess ( ent, shine);
	LC_RETURN_VOID;
}

LC_ENTRY ( EntityTexture ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent = NULL;
	char* tex = NULL;
	int frame = 0;
	int index = 0;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( tex, 1, "%p" );
	if (p_argument_count >= 3){ LC_READARG ( frame, 2, "%d" );}
	if (p_argument_count >= 4){	LC_READARG ( index, 3, "%d" );}
	_EntityTexture ( ent, tex, frame, index );
	LC_RETURN_VOID;
}

LC_ENTRY ( EntityType ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent = NULL;
	int type_no;
	bool recursive = 0;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( type_no, 1, "%d" );
	if (p_argument_count >= 3){	LC_READARG ( recursive, 2, "%d" );}
	_EntityType ( ent, type_no, recursive);
	LC_RETURN_VOID;
}

LC_ENTRY ( EntityVisible ) 
{
	LC_ARG_COUNT ( 2 );
	 char* src_ent = NULL;
	 char* dest_ent = NULL;
	 LC_READARG ( src_ent, 0, "%p" );
	 LC_READARG ( dest_ent, 1, "%p" );
	 int result;
	 result = _EntityVisible ( src_ent, dest_ent );
	 LC_RETURN_INT;
}

LC_ENTRY ( EntityX ) 
{
	LC_ARG_COUNT ( 1 );
	char* ent = NULL;
	bool glob = 0;
	LC_READARG ( ent, 0, "%p" );
	if (p_argument_count >= 2){	LC_READARG ( glob, 1, "%d" );}
	float result;
	result = _EntityX ( ent, glob );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( EntityY ) 
{
	LC_ARG_COUNT ( 1 );
	char* ent = NULL;
	bool glob = 0;
	LC_READARG ( ent, 0, "%p" );
	if (p_argument_count >= 2){	LC_READARG ( glob, 1, "%d" );}
	float result;
	result = _EntityY ( ent, glob );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( EntityYaw ) 
{
	LC_ARG_COUNT ( 1 );
	char* ent = NULL;
	bool glob = 0;
	LC_READARG ( ent, 0, "%p" );
	if (p_argument_count >= 2){	LC_READARG ( glob, 1, "%d" );}
	float result;
	result = _EntityYaw ( ent, glob );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( EntityZ ) 
{
	LC_ARG_COUNT ( 1 );
	char* ent = NULL;
	bool glob = 0;
	LC_READARG ( ent, 0, "%p" );
	if (p_argument_count >= 2){	LC_READARG ( glob, 1, "%d" );}
	float result;
	result = _EntityZ ( ent, glob );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( ExtractAnimSeq ) 
{
	LC_ARG_COUNT ( 3 );
	char* ent = NULL;
	int first_frame;
	int last_frame;
	int seq = 0;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( first_frame, 1, "%d" );
	LC_READARG ( last_frame, 2, "%d" );
	if (p_argument_count >= 4){ LC_READARG ( seq, 3, "%d" );}
	int result;
	result = _ExtractAnimSeq ( ent, first_frame, last_frame, seq );
	LC_RETURN_INT;
}

LC_ENTRY ( FindChild ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent = NULL;
	char* child_name = NULL;
	LC_READARG ( ent, 0, "%p" );
	child_name = p_arguments[1];
	char* result = NULL;
	result = _FindChild ( ent, child_name );
	LC_RETURN_POINTER;
}

LC_ENTRY ( FindSurface ) 
{
	LC_ARG_COUNT ( 2 );
	char* mesh = NULL;
	char* brush = NULL;
	LC_READARG ( mesh, 0, "%p" );
	LC_READARG ( brush, 1, "%p" );
	char* result = NULL;
	result = _FindSurface ( mesh, brush );
	LC_RETURN_POINTER;
}

LC_ENTRY ( FitMesh ) 
{
	LC_ARG_COUNT ( 7 );
	char* mesh = NULL;
	float x;
	float y;
	float z;
	float width;
	float height;
	float depth;
	bool uniform  = 0;
	LC_READARG ( mesh, 0, "%p" );
	LC_READARG ( x, 1, "%f" );
	LC_READARG ( y, 2, "%f" );
	LC_READARG ( z, 3, "%f" );
	LC_READARG ( width, 4, "%f" );
	LC_READARG ( height, 5, "%f" );
	LC_READARG ( depth, 6, "%f" );
	if (p_argument_count >= 8){ LC_READARG ( uniform, 7, "%d" );}
	_FitMesh ( mesh, x, y, z, width, height, depth, uniform );
	LC_RETURN_VOID;
}

LC_ENTRY ( FlipMesh ) 
{
	LC_ARG_COUNT ( 1 );
	char* mesh = NULL;
	LC_READARG ( mesh, 0, "%p" );
	_FlipMesh ( mesh );
	LC_RETURN_VOID;
}

LC_ENTRY ( FreeBrush ) 
{
	LC_ARG_COUNT ( 1 );
	char* brush = NULL;
	LC_READARG ( brush, 0, "%p" );
	_FreeBrush ( brush );
	LC_RETURN_VOID;
}

LC_ENTRY ( FreeEntity ) 
{
	LC_ARG_COUNT ( 1 );
	char* ent = NULL;
	LC_READARG ( ent, 0, "%p" );
	_FreeEntity ( ent);
	LC_RETURN_VOID;
}

LC_ENTRY ( FreeShadow ) 
{
	LC_ARG_COUNT ( 1 );
	char* shad = NULL;
	LC_READARG ( shad, 0, "%p" );
	_FreeShadow ( shad );
	LC_RETURN_VOID;
}

LC_ENTRY ( FreeTexture ) 
{
	LC_ARG_COUNT ( 1 );
	char* tex = NULL;
	LC_READARG ( tex, 0, "%p" );
	_FreeTexture ( tex );
	LC_RETURN_VOID;
}

LC_ENTRY ( GetBrushTexture ) 
{
	LC_ARG_COUNT ( 1 );
	char* brush = NULL;
	int index = 0;
	LC_READARG ( brush, 0, "%p" );
	if (p_argument_count >= 2){ LC_READARG ( index, 1, "%d" );}
	char* result = NULL;
	result = _GetBrushTexture ( brush, index );
	LC_RETURN_POINTER;
}

LC_ENTRY ( GetChild ) 
{
	LC_ARG_COUNT ( 1 );
	char* ent = NULL;
	int child_no = 0;
	LC_READARG ( ent, 0, "%p" );
	if (p_argument_count >= 2){	LC_READARG ( child_no, 1, "%d" );}
	char* result = NULL;
	result = _GetChild ( ent, child_no );
	LC_RETURN_POINTER;
}

LC_ENTRY ( GetEntityBrush ) 
{
	LC_ARG_COUNT ( 1 );
	char* ent = NULL;
	LC_READARG ( ent, 0, "%p" );
	char* result = NULL;
	result = _GetEntityBrush ( ent );
	LC_RETURN_POINTER;
}

LC_ENTRY ( GetEntityType ) 
{
	LC_ARG_COUNT ( 1 );
	char* ent = NULL;
	LC_READARG ( ent, 0, "%p" );
	int result;
	result = _GetEntityType ( ent );
	LC_RETURN_INT;
}

LC_ENTRY ( GetMatElement ) 
{
	LC_ARG_COUNT ( 3 );
	char* ent = NULL;
	int row;
	int col;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( row, 1, "%d" );
	LC_READARG ( col, 2, "%d" );
	float result;
	result = _GetMatElement ( ent, row, col);
	LC_RETURN_FLOAT;
}

LC_ENTRY ( GetParentEntity ) 
{
	LC_ARG_COUNT ( 1 );
	char* ent = NULL;
	LC_READARG ( ent, 0, "%p" );
	char* result = NULL;
	result = _GetParentEntity ( ent );
	LC_RETURN_POINTER;
}

LC_ENTRY ( GetSurface ) 
{
	LC_ARG_COUNT ( 2 );
	char* mesh = NULL;
	int surf_no;
	LC_READARG ( mesh, 0, "%p" );
	LC_READARG ( surf_no, 1, "%d" );
	char* result = NULL;
	result = _GetSurface ( mesh, surf_no);
	LC_RETURN_POINTER;
}

LC_ENTRY ( GetSurfaceBrush ) 
{
	LC_ARG_COUNT ( 1 );
	char* surf = NULL;
	LC_READARG ( surf, 0, "%p" );
	char* result = NULL;
	result = _GetSurfaceBrush ( surf );
	LC_RETURN_POINTER;
}

//LC_ENTRY ( GraphicsResize ) 
//{
//LC_ARG_COUNT ( 2 );
 //int width;
//int height  ;
//LC_READARG ( width, 0, "%d" );
//LC_READARG ( height, 1, "%d" );
//_GraphicsResize ( width, height);
//LC_RETURN_VOID;
//}

LC_ENTRY ( HandleSprite ) 
{
	LC_ARG_COUNT ( 3 );
	char* sprite = NULL;
	float h_x;
	float h_y;
	LC_READARG ( sprite, 0, "%p" );
	LC_READARG ( h_x, 1, "%f" );
	LC_READARG ( h_y, 2, "%f" );
	_HandleSprite ( sprite, h_x, h_y );
	LC_RETURN_VOID;
}

LC_ENTRY ( HideEntity ) 
{
	LC_ARG_COUNT ( 1 );
	char* ent = NULL;
	LC_READARG ( ent, 0, "%p" );
	_HideEntity ( ent );
	LC_RETURN_VOID;
}

LC_ENTRY ( LightColor ) 
{
	LC_ARG_COUNT ( 4 );
	char* light = NULL;
	float red;
	float green;
	float blue;
	LC_READARG ( light, 0, "%p" );
	LC_READARG ( red, 1, "%f" );
	LC_READARG ( green, 2, "%f" );
	LC_READARG ( blue, 3, "%f" );
	_LightColor ( light, red, green, blue);
	LC_RETURN_VOID;
}

LC_ENTRY ( LightConeAngles ) 
{
	LC_ARG_COUNT ( 1 );
	char* light = NULL;
	float inner_ang = 0.0;
	float outer_ang  = 90.0;
	LC_READARG ( light, 0, "%p" );
	if (p_argument_count >= 2){	LC_READARG ( inner_ang, 1, "%f" );}
	if (p_argument_count >= 3){	LC_READARG ( outer_ang, 2, "%f" );}
	_LightConeAngles ( light, inner_ang, outer_ang );
	LC_RETURN_VOID;
}

LC_ENTRY ( LightRange ) 
{
	LC_ARG_COUNT ( 1 );
	char* light = NULL;
	float range = 1000.0;
	LC_READARG ( light, 0, "%p" );
	if (p_argument_count >= 2){	LC_READARG ( range, 1, "%f" );}
	_LightRange ( light, range );
	LC_RETURN_VOID;
}

LC_ENTRY ( LinePick ) 
{
	LC_ARG_COUNT ( 6 );
	float x;
	float y;
	float z;
	float dx;
	float dy;
	float dz;
	float radius = 0.1;
	LC_READARG ( x, 0, "%f" );
	LC_READARG ( y, 1, "%f" );
	LC_READARG ( z, 2, "%f" );
	LC_READARG ( dx, 3, "%f" );
	LC_READARG ( dy, 4, "%f" );
	LC_READARG ( dz, 5, "%f" );
	if (p_argument_count >= 7){	LC_READARG ( radius, 6, "%f" );}
	char* result = NULL;
	result = _LinePick ( x, y, z, dx, dy, dz, radius );
	LC_RETURN_POINTER;
}

LC_ENTRY ( LoadAnimMesh ) 
{
	LC_ARG_COUNT ( 1 );
	char* file = p_arguments[0];
	char* parent = NULL;
	if (p_argument_count >= 2){	LC_READARG ( parent, 1, "%p" );}
	char* result = NULL;
	result = _LoadAnimMesh ( file, parent );
	LC_RETURN_POINTER;
}

LC_ENTRY ( LoadAnimTexture ) 
{
	LC_ARG_COUNT ( 6 );
	char* file = p_arguments[0];
	int flags;
	int frame_width;
	int frame_height;
	int first_frame;
	int frame_count;
	LC_READARG ( flags, 1, "%d" );
	LC_READARG ( frame_width, 2, "%d" );
	LC_READARG ( frame_height, 3, "%d" );
	LC_READARG ( first_frame, 4, "%d" );
	LC_READARG ( frame_count, 5, "%d" );
	char* result = NULL;
	result = _LoadAnimTexture ( file, flags, frame_width, frame_height, first_frame, frame_count );
	LC_RETURN_POINTER;
}

LC_ENTRY ( LoadBrush ) 
{
	LC_ARG_COUNT ( 1 );
	char* file = p_arguments[0];
	int flags = 1;
	float u_scale = 1;
	float v_scale = 1;
	if (p_argument_count >= 2){	LC_READARG ( flags, 1, "%d" );}
	if (p_argument_count >= 3){	LC_READARG ( u_scale, 2, "%f" );}
	if (p_argument_count >= 4){	LC_READARG ( v_scale, 3, "%f" );}
	char* result = NULL;
	result = _LoadBrush ( file, flags, u_scale, v_scale );
	LC_RETURN_POINTER;
}

LC_ENTRY ( LoadMesh ) 
{
	LC_ARG_COUNT ( 1 );
	char* file = p_arguments[0];
	char* parent = NULL;
	if (p_argument_count >= 2){	LC_READARG ( parent, 1, "%p" );}
	char* result = NULL;
	result = _LoadMesh ( file, parent );
	LC_RETURN_POINTER;
}

LC_ENTRY ( LoadTerrain ) 
{
	LC_ARG_COUNT ( 1 );
	char* file = p_arguments[0];
	char* parent = NULL;
	if (p_argument_count >= 2){	LC_READARG ( parent, 1, "%p" );}
	char* result = NULL;
	result = _LoadTerrain ( file, parent );
	LC_RETURN_POINTER;
}

LC_ENTRY ( LoadTexture ) 
{
	LC_ARG_COUNT ( 1 );
	 char* file = p_arguments[0];
	 int flags = 1;
	 if (p_argument_count >= 2){ LC_READARG ( flags, 1, "%d" );}
	 char* result = NULL;
	 result = _LoadTexture ( file, flags );
	 LC_RETURN_POINTER;
}

LC_ENTRY ( LoadSprite ) 
{
	LC_ARG_COUNT ( 1 );
	char* tex_file = p_arguments[0];
	int tex_flag = 1;
	char* parent = NULL;
	if (p_argument_count>= 2){ LC_READARG ( tex_flag, 1, "%d" );}
	if (p_argument_count >= 3){	LC_READARG ( parent, 2, "%p" );}
	char* result = NULL;
	result = _LoadSprite ( tex_file, tex_flag, parent );
	LC_RETURN_POINTER;
}

LC_ENTRY ( MeshCSG ) 
{
	LC_ARG_COUNT ( 3 );
	char* m1 = NULL;
	char* m2 = NULL;
	int method;
	LC_READARG ( m1, 0, "%p" );
	LC_READARG ( m2, 1, "%p" );
	LC_READARG ( method, 2, "%d" );
	char* result = NULL;
	result = _MeshCSG ( m1, m2, method );
	LC_RETURN_POINTER;
}

LC_ENTRY ( MeshDepth ) 
{
	LC_ARG_COUNT ( 1 );
	char* mesh = NULL;
	LC_READARG ( mesh, 0, "%p" );
	float result;
	result = _MeshDepth ( mesh );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( MeshesIntersect ) 
{
	LC_ARG_COUNT ( 2 );
	 char* mesh1 = NULL;
	 char* mesh2 = NULL;
	 LC_READARG ( mesh1, 0, "%p" );
	 LC_READARG ( mesh2, 1, "%p" );
	 int result;
	 result = _MeshesIntersect ( mesh1, mesh2 );
	 LC_RETURN_INT;
}

LC_ENTRY ( MeshHeight ) 
{
	LC_ARG_COUNT ( 1 );
	char* mesh = NULL;
	LC_READARG ( mesh, 0, "%p" );
	float result;
	result = _MeshHeight ( mesh );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( MeshWidth ) 
{
	LC_ARG_COUNT ( 1 );
	char* mesh = NULL;
	LC_READARG ( mesh, 0, "%p" );
	float result;
	result = _MeshWidth ( mesh );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( ModifyTerrain ) 
{
	LC_ARG_COUNT ( 4 );
	char* terr = NULL;
	int x;
	int y;
	float new_height;
	LC_READARG ( terr, 0, "%p" );
	LC_READARG ( x, 1, "%d" );
	LC_READARG ( y, 2, "%d" );
	LC_READARG ( new_height, 3, "%f" );
	_ModifyTerrain ( terr, x, y, new_height);
	LC_RETURN_VOID;
}

LC_ENTRY ( MoveEntity ) 
{
	LC_ARG_COUNT ( 4 );
	char* ent = NULL;
	float x;
	float y;
	float z;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( x, 1, "%f" );
	LC_READARG ( y, 2, "%f" );
	LC_READARG ( z, 3, "%f" );
	_MoveEntity ( ent, x, y, z);
	LC_RETURN_VOID;
}

LC_ENTRY ( NameEntity ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent = NULL;
	char* name = p_arguments[1];
	LC_READARG ( ent, 0, "%p" );
	_NameEntity ( ent, name );
	LC_RETURN_VOID;
}

LC_ENTRY ( PaintEntity ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent = NULL;
	char* brush = NULL;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( brush, 1, "%p" );
	_PaintEntity ( ent, brush );
	LC_RETURN_VOID;
}

LC_ENTRY ( PaintMesh ) 
{
	LC_ARG_COUNT ( 2 );
	char* mesh = NULL;
	char* brush = NULL;
	LC_READARG ( mesh, 0, "%p" );
	LC_READARG ( brush, 1, "%p" );
	_PaintMesh ( mesh, brush );
	LC_RETURN_VOID;
}

LC_ENTRY ( PaintSurface ) 
{
	LC_ARG_COUNT ( 2 );
	char* surf = NULL;
	char* brush = NULL;
	LC_READARG ( surf, 0, "%p" );
	LC_READARG ( brush, 1, "%p" );
	_PaintSurface ( surf, brush);
	LC_RETURN_VOID;
}

LC_ENTRY ( PickedEntity ) 
{
	char* result = NULL;
	result = _PickedEntity ( );
	LC_RETURN_POINTER;
}

LC_ENTRY ( PickedNX ) 
{
	float result;
	result = _PickedNX ( );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( PickedNY ) 
{
	float result;
	result = _PickedNY ( );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( PickedNZ ) 
{
	float result;
	result = _PickedNZ ( );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( PickedSurface ) 
{
	char* result = NULL;
	result = _PickedSurface ( );
	LC_RETURN_POINTER;
}

LC_ENTRY ( PickedTime ) 
{
	float result;
	result = _PickedTime ( );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( PickedTriangle ) 
{
	int result;
	result = _PickedTriangle ( );
	LC_RETURN_INT;
}

LC_ENTRY ( PickedX ) 
{
	float result;
	result = _PickedX ( );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( PickedY ) 
{
	float result;
	result = _PickedY ( );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( PickedZ ) 
{
	float result;
	result = _PickedZ ( );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( PointEntity ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent = NULL;
	char* target_ent = NULL;
	float roll = 0.0;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( target_ent, 1, "%p" );
	if (p_argument_count >= 3){ LC_READARG ( roll, 2, "%f" );}
	_PointEntity ( ent, target_ent, roll );
	LC_RETURN_VOID;
}

LC_ENTRY ( PositionEntity ) 
{
	LC_ARG_COUNT ( 4 );
	char* ent = NULL;
	float x;
	float y;
	float z;
	bool glob = 0;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( x, 1, "%f" );
	LC_READARG ( y, 2, "%f" );
	LC_READARG ( z, 3, "%f" );
	if (p_argument_count >= 5){	LC_READARG ( glob, 4, "%d" );}
	_PositionEntity ( ent, x, y, z, glob );
	LC_RETURN_VOID;
}

LC_ENTRY ( PositionMesh ) 
{
	LC_ARG_COUNT ( 4 );
	char* mesh = NULL;
	float px;
	float py;
	float pz;
	LC_READARG ( mesh, 0, "%p" );
	LC_READARG ( px, 1, "%f" );
	LC_READARG ( py, 2, "%f" );
	LC_READARG ( pz, 3, "%f" );
	_PositionMesh ( mesh, px, py, pz );
	LC_RETURN_VOID;
}

LC_ENTRY ( PositionTexture ) 
{
	LC_ARG_COUNT ( 3 );
	char* tex = NULL;
	float u_pos;
	float v_pos;
	LC_READARG ( tex, 0, "%p" );
	LC_READARG ( u_pos, 1, "%f" );
	LC_READARG ( v_pos, 2, "%f" );
	_PositionTexture ( tex, u_pos, v_pos );
	LC_RETURN_VOID;
}

LC_ENTRY ( ProjectedX ) 
{
	float result;
	result = _ProjectedX ( );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( ProjectedY ) 
{
	float result;
	result = _ProjectedY ( );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( ProjectedZ ) 
{
	float result;
	result = _ProjectedZ ( );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( RenderWorld ) 
{
	_RenderWorld ( );
	LC_RETURN_VOID;
}

LC_ENTRY ( RepeatMesh ) 
{
	LC_ARG_COUNT ( 2 );
	char* mesh = NULL;
	char* parent;
	LC_READARG ( mesh, 0, "%p" );
	LC_READARG ( parent, 1, "%p" );
	char* result = NULL;
	result = _RepeatMesh ( mesh, parent );
	LC_RETURN_POINTER;
}

LC_ENTRY ( ResetEntity ) 
{
	LC_ARG_COUNT ( 1 );
	char* ent = NULL;
	LC_READARG ( ent, 0, "%p" );
	_ResetEntity ( ent );
	LC_RETURN_VOID;
}

LC_ENTRY ( RotateEntity ) 
{
	LC_ARG_COUNT ( 4 );
	char* ent = NULL;
	float x;
	float y;
	float z;
	bool glob = 0;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( x, 1, "%f" );
	LC_READARG ( y, 2, "%f" );
	LC_READARG ( z, 3, "%f" );
	if (p_argument_count >=5 ){	LC_READARG ( glob, 4, "%d" );}
	_RotateEntity ( ent, x, y, z, glob );
	LC_RETURN_VOID;
}
LC_ENTRY ( RotateMesh ) 
{
	LC_ARG_COUNT ( 4 );
	char* mesh = NULL;
	float pitch;
	float yaw;
	float roll;
	LC_READARG ( mesh, 0, "%p" );
	LC_READARG ( pitch, 1, "%f" );
	LC_READARG ( yaw, 2, "%f" );
	LC_READARG ( roll, 3, "%f" );
	_RotateMesh ( mesh, pitch, yaw, roll );
	LC_RETURN_VOID;
}

LC_ENTRY ( RotateSprite ) 
{
	LC_ARG_COUNT ( 2 );
	char* sprite = NULL;
	float ang;
	LC_READARG ( sprite, 0, "%p" );
	LC_READARG ( ang, 1, "%f" );
	_RotateSprite ( sprite, ang );
	LC_RETURN_VOID;
}

LC_ENTRY ( RotateTexture ) 
{
	LC_ARG_COUNT ( 2 );
	char* tex = NULL;
	float ang;
	LC_READARG ( tex, 0, "%p" );
	LC_READARG ( ang, 1, "%f" );
	_RotateTexture ( tex, ang );
	LC_RETURN_VOID;
}

LC_ENTRY ( ScaleEntity ) 
{
	LC_ARG_COUNT ( 4 );
	char* ent = NULL;
	float x;
	float y;
	float z;
	bool glob = 0;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( x, 1, "%f" );
	LC_READARG ( y, 2, "%f" );
	LC_READARG ( z, 3, "%f" );
	if (p_argument_count >=5 ){	LC_READARG ( glob, 4, "%d" );}
	_ScaleEntity ( ent, x, y, z, glob );
	LC_RETURN_VOID;
}

LC_ENTRY ( ScaleMesh ) 
{
	LC_ARG_COUNT ( 4 );
	char* mesh = NULL;
	float sx;
	float sy;
	float sz;
	LC_READARG ( mesh, 0, "%p" );
	LC_READARG ( sx, 1, "%f" );
	LC_READARG ( sy, 2, "%f" );
	LC_READARG ( sz, 3, "%f" );
	_ScaleMesh ( mesh, sx, sy, sz );
	LC_RETURN_VOID;
}

LC_ENTRY ( ScaleSprite ) 
{
	LC_ARG_COUNT ( 3 );
	char* sprite = NULL;
	float s_x;
	float s_y;
	LC_READARG ( sprite, 0, "%p" );
	LC_READARG ( s_x, 1, "%f" );
	LC_READARG ( s_y, 2, "%f" );
	_ScaleSprite ( sprite, s_x, s_y );
	LC_RETURN_VOID;
}

LC_ENTRY ( ScaleTexture ) 
{
	LC_ARG_COUNT ( 3 );
	char* tex = NULL;
	float u_scale;
	float v_scale;
	LC_READARG ( tex, 0, "%p" );
	LC_READARG ( u_scale, 1, "%f" );
	LC_READARG ( v_scale, 2, "%f" );
	_ScaleTexture ( tex, u_scale, v_scale );
	LC_RETURN_VOID;
}

LC_ENTRY ( SetAnimTime ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent = NULL;
	float time;
	int seq = NULL;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( time, 1, "%f" );
	if (p_argument_count >=3 ){	LC_READARG ( seq, 2, "%d" );}
	_SetAnimTime ( ent, time, seq );
	LC_RETURN_VOID;
}

LC_ENTRY ( SetCubeFace ) 
{
	LC_ARG_COUNT ( 2 );
	char* tex = NULL;
	int face;
	LC_READARG ( tex, 0, "%p" );
	LC_READARG ( face, 1, "%d" );
	_SetCubeFace ( tex, face );
	LC_RETURN_VOID;
}

LC_ENTRY ( SetCubeMode ) 
{
	LC_ARG_COUNT ( 1 );
	char* tex = NULL;
	int mode = 1;
	LC_READARG ( tex, 0, "%p" );
	if (p_argument_count >=2 ){	LC_READARG ( mode, 1, "%d" );}
	_SetCubeMode ( tex, mode );
	LC_RETURN_VOID;
}

LC_ENTRY ( ShowEntity ) 
{
	LC_ARG_COUNT ( 1 );
	char* ent = NULL;
	LC_READARG ( ent, 0, "%p" );
	_ShowEntity ( ent );
	LC_RETURN_VOID;
}

LC_ENTRY ( SpriteViewMode ) 
{
	LC_ARG_COUNT ( 1 );
	char* sprite = NULL;
	int mode = 1;
	LC_READARG ( sprite, 0, "%p" );
	if (p_argument_count >=2 ){	LC_READARG ( mode, 1, "%d" );}
	_SpriteViewMode ( sprite, mode );
	LC_RETURN_VOID;
}

LC_ENTRY ( StencilAlpha ) 
{
	LC_ARG_COUNT ( 2 );
	char* stencil = NULL;
	float a;
	LC_READARG ( stencil, 0, "%p" );
	LC_READARG ( a, 1, "%f" );
	_StencilAlpha ( stencil, a );
	LC_RETURN_VOID;
}

LC_ENTRY ( StencilClsColor ) 
{
	LC_ARG_COUNT ( 4 );
	char* stencil = NULL;
	float r;
	float g;
	float b;
	LC_READARG ( stencil, 0, "%p" );
	LC_READARG ( r, 1, "%f" );
	LC_READARG ( g, 2, "%f" );
	LC_READARG ( b, 3, "%f" );
	_StencilClsColor ( stencil, r, g, b );
	LC_RETURN_VOID;
}

LC_ENTRY ( StencilMesh ) 
{
	LC_ARG_COUNT ( 2 );
	char* stencil = NULL;
	char* mesh;
	int mode = 1;
	LC_READARG ( stencil, 0, "%p" );
	LC_READARG ( mesh, 1, "%p" );
	if (p_argument_count >= 3){	LC_READARG ( mode, 2, "%d" );}
	_StencilMesh ( stencil, mesh, mode );
	LC_RETURN_VOID;
}

LC_ENTRY ( StencilMode ) 
{
	LC_ARG_COUNT ( 2 );
	char* stencil = NULL;
	int m;
	int o = 1;
	LC_READARG ( stencil, 0, "%p" );
	LC_READARG ( m, 1, "%d" );
	if (p_argument_count >= 3){	LC_READARG ( o, 2, "%d" );}
	_StencilMode ( stencil, m, o );
	LC_RETURN_VOID;
}

LC_ENTRY ( TerrainHeight ) 
{
	LC_ARG_COUNT ( 3 );
	char* terr = NULL;
	int x;
	int z;
	LC_READARG ( terr, 0, "%p" );
	LC_READARG ( x, 1, "%d" );
	LC_READARG ( z, 2, "%d" );
	float result;
	result = _TerrainHeight ( terr, x, z );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( TerrainX ) 
{
	LC_ARG_COUNT ( 4 );
	char* terr = NULL;
	float x;
	float y;
	float z;
	LC_READARG ( terr, 0, "%p" );
	LC_READARG ( x, 1, "%f" );
	LC_READARG ( y, 2, "%f" );
	LC_READARG ( z, 3, "%f" );
	float result;
	result = _TerrainX ( terr, x, y, z );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( TerrainY ) 
{
	LC_ARG_COUNT ( 4 );
	char* terr = NULL;
	float x;
	float y;
	float z;
	LC_READARG ( terr, 0, "%p" );
	LC_READARG ( x, 1, "%f" );
	LC_READARG ( y, 2, "%f" );
	LC_READARG ( z, 3, "%f" );
	float result;
	result = _TerrainY ( terr, x, y, z );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( TerrainZ ) 
{
	LC_ARG_COUNT ( 4 );
	char* terr = NULL;
	float x;
	float y;
	float z;
	LC_READARG ( terr, 0, "%p" );
	LC_READARG ( x, 1, "%f" );
	LC_READARG ( y, 2, "%f" );
	LC_READARG ( z, 3, "%f" );
	float result;
	result = _TerrainZ ( terr, x, y, z );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( TextureBlend ) 
{
	LC_ARG_COUNT ( 1 );
	char* tex = NULL;
	int blend = 2;
	LC_READARG ( tex, 0, "%p" );
	if (p_argument_count >=2 ){	LC_READARG ( blend, 1, "%d" );}
	_TextureBlend ( tex, blend );
	LC_RETURN_VOID;
}

LC_ENTRY ( TextureCoords ) 
{
	LC_ARG_COUNT ( 1 );
	char* tex = NULL;
	int coords = 0;
	LC_READARG ( tex, 0, "%p" );
	if (p_argument_count >=2 ){	LC_READARG ( coords, 1, "%d" );}
	_TextureCoords ( tex, coords );
	LC_RETURN_VOID;
}

LC_ENTRY ( TextureHeight ) 
{
	LC_ARG_COUNT ( 1 );
	char* tex = NULL;
	LC_READARG ( tex, 0, "%p" );
	int result;
	result = _TextureHeight ( tex );
	LC_RETURN_INT;
}

LC_ENTRY ( TextureFilter ) 
{
	LC_ARG_COUNT ( 1 );
	char* match_text = p_arguments[0];
	int flags = 9;
	if (p_argument_count >=2 ){	LC_READARG ( flags, 1, "%d" );}
	_TextureFilter ( match_text, flags );
	LC_RETURN_VOID;
}

LC_ENTRY ( TextureWidth ) 
{
	LC_ARG_COUNT ( 1 );
	char* tex = NULL;
	LC_READARG ( tex, 0, "%p" );
	int result;
	result = _TextureWidth ( tex );
	LC_RETURN_INT;
}

LC_ENTRY ( TFormedX ) 
{
	float result;
	result = _TFormedX ( );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( TFormedY ) 
{
	float result;
	result = _TFormedY ( );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( TFormedZ ) 
{
	float result;
	result = _TFormedZ ( );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( TFormNormal ) 
{
	LC_ARG_COUNT ( 5 );
	float x;
	float y;
	float z;
	char* src_ent = NULL;
	char* dest_ent = NULL;
	LC_READARG ( x, 0, "%f" );
	LC_READARG ( y, 1, "%f" );
	LC_READARG ( z, 2, "%f" );
	LC_READARG ( src_ent, 3, "%p" );
	LC_READARG ( dest_ent, 4, "%p" );
	_TFormNormal ( x, y, z, src_ent, dest_ent );
	LC_RETURN_VOID;
}

LC_ENTRY ( TFormPoint ) 
{
	LC_ARG_COUNT ( 5 );
	float x;
	float y;
	float z;
	char* src_ent = NULL;
	char* dest_ent = NULL;
	LC_READARG ( x, 0, "%f" );
	LC_READARG ( y, 1, "%f" );
	LC_READARG ( z, 2, "%f" );
	LC_READARG ( src_ent, 3, "%p" );
	LC_READARG ( dest_ent, 4, "%p" );
	_TFormPoint ( x, y, z, src_ent, dest_ent );
	LC_RETURN_VOID;
}

LC_ENTRY ( TFormVector ) 
{
	LC_ARG_COUNT ( 5 );
	float x;
	float y;
	float z;
	char* src_ent = NULL;
	char* dest_ent = NULL;
	LC_READARG ( x, 0, "%f" );
	LC_READARG ( y, 1, "%f" );
	LC_READARG ( z, 2, "%f" );
	LC_READARG ( src_ent, 3, "%p" );
	LC_READARG ( dest_ent, 4, "%p" );
	_TFormVector ( x, y, z, src_ent, dest_ent );
	LC_RETURN_VOID;
}

LC_ENTRY ( TranslateEntity ) 
{
	LC_ARG_COUNT ( 4 );
	char* ent = NULL;
	float x;
	float y;
	float z;
	bool glob = 0;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( x, 1, "%f" );
	LC_READARG ( y, 2, "%f" );
	LC_READARG ( z, 3, "%f" );
	if (p_argument_count >=5 ){	LC_READARG ( glob, 4, "%d" );}
	_TranslateEntity ( ent, x, y, z, glob);
	LC_RETURN_VOID;
}

LC_ENTRY ( TriangleVertex ) 
{
	LC_ARG_COUNT ( 3 );
	char* surf = NULL;
	int tri_no;
	int corner;
	LC_READARG ( surf, 0, "%p" );
	LC_READARG ( tri_no, 1, "%d" );
	LC_READARG ( corner, 2, "%d" );
	int result;
	result = _TriangleVertex ( surf, tri_no, corner );
	LC_RETURN_INT;
}

LC_ENTRY ( TurnEntity ) 
{
	LC_ARG_COUNT ( 4 );
	char* ent = NULL;
	float x;
	float y;
	float z;
	bool glob = 0;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( x, 1, "%f" );
	LC_READARG ( y, 2, "%f" );
	LC_READARG ( z, 3, "%f" );
	if (p_argument_count >=5 ){	LC_READARG ( glob, 4, "%d" );}
	_TurnEntity ( ent, x, y, z, glob );
	LC_RETURN_VOID;
}

LC_ENTRY ( UpdateNormals ) 
{
	LC_ARG_COUNT ( 1 );
	char* mesh = NULL;
	LC_READARG ( mesh, 0, "%p" );
	_UpdateNormals ( mesh );
	LC_RETURN_VOID;
}

LC_ENTRY ( UpdateTexCoords ) 
{
	LC_ARG_COUNT ( 1 );
	char* surf = NULL;
	LC_READARG ( surf, 0, "%p" );
	_UpdateTexCoords ( surf );
	LC_RETURN_VOID;
}

LC_ENTRY ( UpdateWorld ) 
{
	float anim_speed = 1;
	if (p_argument_count >=1 ){	LC_READARG ( anim_speed, 0, "%f" );}
	_UpdateWorld ( anim_speed );
	LC_RETURN_VOID;
}

LC_ENTRY ( UseStencil ) 
{
	LC_ARG_COUNT ( 1 );
	char* stencil = NULL;
	LC_READARG ( stencil, 0, "%p" );
	_UseStencil ( stencil );
	LC_RETURN_VOID;
}

LC_ENTRY ( VectorPitch ) 
{
	LC_ARG_COUNT ( 3 );
	float vx;
	float vy;
	float vz;
	LC_READARG ( vx, 0, "%f" );
	LC_READARG ( vy, 1, "%f" );
	LC_READARG ( vz, 2, "%f" );
	float result;
	result = _VectorPitch ( vx, vy, vz );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( VectorYaw ) 
{
	LC_ARG_COUNT ( 3 );
	float vx;
	float vy;
	float vz;
	LC_READARG ( vx, 0, "%f" );
	LC_READARG ( vy, 1, "%f" );
	LC_READARG ( vz, 2, "%f" );
	float result;
	result = _VectorYaw ( vx, vy, vz );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( VertexAlpha ) 
{
	LC_ARG_COUNT ( 2 );
	char* surf = NULL;
	int vid;
	LC_READARG ( surf, 0, "%p" );
	LC_READARG ( vid, 1, "%d" );
	float result;
	result = _VertexAlpha ( surf, vid );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( VertexBlue ) 
{
	LC_ARG_COUNT ( 2 );
	char* surf = NULL;
	int vid;
	LC_READARG ( surf, 0, "%p" );
	LC_READARG ( vid, 1, "%d" );
	float result;
	result = _VertexBlue ( surf, vid );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( VertexColor ) 
{
	LC_ARG_COUNT ( 5 );
	char* surf = NULL;
	int vid;
	float r;
	float g;
	float b;
	float a = 1.0;
	LC_READARG ( surf, 0, "%p" );
	LC_READARG ( vid, 1, "%d" );
	LC_READARG ( r, 2, "%f" );
	LC_READARG ( g, 3, "%f" );
	LC_READARG ( b, 4, "%f" );
	if (p_argument_count >= 6 ){ LC_READARG ( a, 5, "%f" );}
	_VertexColor ( surf, vid, r, g, b, a );
	LC_RETURN_VOID;
}

LC_ENTRY ( VertexCoords ) 
{
	LC_ARG_COUNT ( 5 );
	char* surf = NULL;
	int vid;
	float x;
	float y;
	float z;
	LC_READARG ( surf, 0, "%p" );
	LC_READARG ( vid, 1, "%d" );
	LC_READARG ( x, 2, "%f" );
	LC_READARG ( y, 3, "%f" );
	LC_READARG ( z, 4, "%f" );
	_VertexCoords ( surf, vid, x, y, z );
	LC_RETURN_VOID;
}

LC_ENTRY ( VertexGreen ) 
{
	LC_ARG_COUNT ( 2 );
	char* surf = NULL;
	int vid;
	LC_READARG ( surf, 0, "%p" );
	LC_READARG ( vid, 1, "%d" );
	float result;
	result = _VertexGreen ( surf, vid );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( VertexNormal ) 
{
	LC_ARG_COUNT ( 5 );
	char* surf = NULL;
	int vid;
	float nx;
	float ny;
	float nz;
	LC_READARG ( surf, 0, "%p" );
	LC_READARG ( vid, 1, "%d" );
	LC_READARG ( nx, 2, "%f" );
	LC_READARG ( ny, 3, "%f" );
	LC_READARG ( nz, 4, "%f" );
	_VertexNormal ( surf, vid, nx, ny, nz );
	LC_RETURN_VOID;
}

LC_ENTRY ( VertexNX ) 
{
	LC_ARG_COUNT ( 2 );
	char* surf = NULL;
	int vid;
	LC_READARG ( surf, 0, "%p" );
	LC_READARG ( vid, 1, "%d" );
	float result;
	result = _VertexNX ( surf, vid );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( VertexNY ) 
{
	LC_ARG_COUNT ( 2 );
	char* surf = NULL;
	int vid;
	LC_READARG ( surf, 0, "%p" );
	LC_READARG ( vid, 1, "%d" );
	float result;
	result = _VertexNY ( surf, vid );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( VertexNZ ) 
{
	LC_ARG_COUNT ( 2 );
	char* surf = NULL;
	int vid;
	LC_READARG ( surf, 0, "%p" );
	LC_READARG ( vid, 1, "%d" );
	float result;
	result = _VertexNZ ( surf, vid );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( VertexRed ) 
{
	LC_ARG_COUNT ( 2 );
	char* surf = NULL;
	int vid;
	LC_READARG ( surf, 0, "%p" );
	LC_READARG ( vid, 1, "%d" );
	float result;
	result = _VertexRed ( surf, vid );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( VertexTexCoords ) 
{
	LC_ARG_COUNT ( 6 );
	char* surf = NULL;
	int vid;
	float u;
	float v;
	float w;
	int coord_set;
	LC_READARG ( surf, 0, "%p" );
	LC_READARG ( vid, 1, "%d" );
	LC_READARG ( u, 2, "%f" );
	LC_READARG ( v, 3, "%f" );
	LC_READARG ( w, 4, "%f" );
	LC_READARG ( coord_set, 5, "%d" );
	_VertexTexCoords ( surf, vid, u, v, w, coord_set );
	LC_RETURN_VOID;
}

LC_ENTRY ( VertexU ) 
{
	LC_ARG_COUNT ( 2 );
	char* surf = NULL;
	int vid;
	int coord_set;
	LC_READARG ( surf, 0, "%p" );
	LC_READARG ( vid, 1, "%d" );
	LC_READARG ( coord_set, 2, "%d" );
	float result;
	result = _VertexU ( surf, vid, coord_set );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( VertexV ) 
{
	LC_ARG_COUNT ( 3 );
	char* surf = NULL;
	int vid;
	int coord_set;
	LC_READARG ( surf, 0, "%p" );
	LC_READARG ( vid, 1, "%d" );
	LC_READARG ( coord_set, 2, "%d" );
	float result;
	result = _VertexV ( surf, vid, coord_set );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( VertexW ) 
{
	LC_ARG_COUNT ( 3 );
	char* surf = NULL;
	int vid;
	int coord_set;
	LC_READARG ( surf, 0, "%p" );
	LC_READARG ( vid, 1, "%d" );
	LC_READARG ( coord_set, 2, "%d" );
	float result;
	result = _VertexW ( surf, vid, coord_set );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( VertexX ) 
{
	LC_ARG_COUNT ( 2 );
	char* surf = NULL;
	int vid;
	LC_READARG ( surf, 0, "%p" );
	LC_READARG ( vid, 1, "%d" );
	float result;
	result = _VertexX ( surf, vid );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( VertexY ) 
{
	LC_ARG_COUNT ( 2 );
	char* surf = NULL;
	int vid;
	LC_READARG ( surf, 0, "%p" );
	LC_READARG ( vid, 1, "%d" );
	float result;
	result = _VertexY ( surf, vid );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( VertexZ ) 
{
	LC_ARG_COUNT ( 2 );
	char* surf = NULL;
	int vid;
	LC_READARG ( surf, 0, "%p" );
	LC_READARG ( vid, 1, "%d" );
	float result;
	result = _VertexZ ( surf, vid );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( VoxelSpriteMaterial ) 
{
	LC_ARG_COUNT ( 2 );
	char* voxelspr = NULL;
	char* mat = NULL;
	LC_READARG ( voxelspr, 0, "%p" );
	LC_READARG ( mat, 1, "%p" );
	_VoxelSpriteMaterial ( voxelspr, mat );
	LC_RETURN_VOID;
}

LC_ENTRY ( Wireframe ) 
{
	LC_ARG_COUNT ( 1 );
	int enable = 0;
	LC_READARG ( enable, 0, "%d" );
	_Wireframe ( enable );
	LC_RETURN_VOID;
}

LC_ENTRY ( EntityScaleX ) 
{
	LC_ARG_COUNT ( 1 );
	char* ent = NULL;
	bool glob = 0;
	LC_READARG ( ent, 0, "%p" );
	if (p_argument_count >= 2){ LC_READARG( glob, 1, "%d" );}
	float result;
	result = _EntityScaleX ( ent, glob );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( EntityScaleY ) 
{
	LC_ARG_COUNT ( 1 );
	char* ent = NULL;
	bool glob = 0;
	LC_READARG ( ent, 0, "%p" );
	if (p_argument_count >= 2){ LC_READARG( glob, 1, "%d" );}
	float result;
	result = _EntityScaleY ( ent, glob );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( EntityScaleZ ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent = NULL;
	bool glob = 0;
	LC_READARG ( ent, 0, "%p" );
	if (p_argument_count >= 2){ LC_READARG( glob, 1, "%d" );}
	float result;
	result = _EntityScaleZ ( ent, glob );
	LC_RETURN_FLOAT;
}

LC_ENTRY ( LoadShader ) 
{
	LC_ARG_COUNT ( 3 );
	char* ShaderName = p_arguments[0];
	char* VshaderFileName = p_arguments[1];
	char* FshaderFileName  = p_arguments[2];
	char* result = NULL;
	result = _LoadShader ( ShaderName, VshaderFileName, FshaderFileName );
	LC_RETURN_POINTER;
}

LC_ENTRY ( CreateShader ) 
{
	LC_ARG_COUNT ( 3 );
	char* ShaderName;
	char* VshaderString;
	char* FshaderString;
	LC_READARG ( ShaderName, 0, "%p" );
	LC_READARG ( VshaderString, 1, "%p" );
	LC_READARG ( FshaderString, 2, "%p" );
	char* result = NULL;
	result = _CreateShader ( ShaderName, VshaderString, FshaderString );
	LC_RETURN_POINTER;
}

LC_ENTRY ( ShadeSurface ) 
{
	LC_ARG_COUNT ( 2 );
	char* surf = NULL;
	char* material = NULL;
	LC_READARG ( surf, 0, "%p" );
	LC_READARG ( material, 1, "%p" );
	_ShadeSurface ( surf, material );
	LC_RETURN_VOID;
}

LC_ENTRY ( ShadeMesh ) 
{
	LC_ARG_COUNT ( 2 );
	char* mesh = NULL;
	char* material = NULL;
	LC_READARG ( mesh, 0, "%p" );
	LC_READARG ( material, 1, "%p" );
	_ShadeMesh ( mesh, material);
	LC_RETURN_VOID;
}

LC_ENTRY ( ShadeEntity ) 
{
	LC_ARG_COUNT ( 2 );
	char* ent = NULL;
	char* material= NULL;
	LC_READARG ( ent, 0, "%p" );
	LC_READARG ( material, 1, "%p" );
	_ShadeEntity ( ent, material );
	LC_RETURN_VOID;
}

LC_ENTRY ( ShaderTexture ) 
{
	LC_ARG_COUNT ( 4 );
	char* material = NULL;
	char* tex = NULL;
	char* name = p_arguments[2];
	int index;
	LC_READARG ( material, 0, "%p" );
	LC_READARG ( tex, 1, "%p" );
	LC_READARG ( index, 3, "%d" );
	_ShaderTexture ( material, tex, name, index );
	LC_RETURN_VOID;
}

LC_ENTRY ( SetFloat ) 
{
	LC_ARG_COUNT ( 3 );
	char* material = NULL;
	char* name = p_arguments[1];
	float v1;
	LC_READARG ( material, 0, "%p" );
	LC_READARG ( v1, 2, "%f" );
	_SetFloat ( material, name, v1 );
	LC_RETURN_VOID;
}

LC_ENTRY ( SetFloat2 ) 
{
	LC_ARG_COUNT ( 4 );
	char* material = NULL;
	char* name = p_arguments[1];
	float v1;
	float v2;
	LC_READARG ( material, 0, "%p" );
	LC_READARG ( v1, 2, "%f" );
	LC_READARG ( v2, 3, "%f" );
	_SetFloat2 ( material, name, v1, v2 );
	LC_RETURN_VOID;
}

LC_ENTRY ( SetFloat3 ) 
{
	LC_ARG_COUNT ( 5 );
	char* material = NULL;
	char* name = p_arguments[1];
	float v1;
	float v2;
	float v3;
	LC_READARG ( material, 0, "%p" );
	LC_READARG ( v1, 2, "%f" );
	LC_READARG ( v2, 3, "%f" );
	LC_READARG ( v3, 4, "%f" );
	_SetFloat3 ( material, name, v1, v2, v3 );
	LC_RETURN_VOID;
}

LC_ENTRY ( SetFloat4 ) 
{
	LC_ARG_COUNT ( 6 );
	char* material = NULL;
	char* name = p_arguments[1];
	float v1;
	float v2;
	float v3;
	float v4;
	LC_READARG ( material, 0, "%p" );
	LC_READARG ( v1, 2, "%f" );
	LC_READARG ( v2, 3, "%f" );
	LC_READARG ( v3, 4, "%f" );
	LC_READARG ( v4, 5, "%f" );
	_SetFloat4 ( material, name, v1, v2, v3, v4 );
	LC_RETURN_VOID;
}

LC_ENTRY ( UseFloat ) 
{
	LC_ARG_COUNT ( 3 );
	char* material = NULL;
	char* name = p_arguments[1];
	float* v1;
	LC_READARG ( material, 0, "%p" );
	LC_READARG ( name, 1, "%p" );
	LC_READARG ( v1, 2, "%p" );
	_UseFloat ( material, name, v1 );
	LC_RETURN_VOID;
}

LC_ENTRY ( UseFloat2 ) 
{
	LC_ARG_COUNT ( 4 );
	char* material = NULL;
	char* name = p_arguments[1];
	float* v1;
	float* v2;
	LC_READARG ( material, 0, "%p" );
	LC_READARG ( v1, 2, "%p" );
	LC_READARG ( v2, 3, "%p" );
	_UseFloat2 ( material, name, v1, v2 );
	LC_RETURN_VOID;
}

LC_ENTRY ( UseFloat3 ) 
{
	LC_ARG_COUNT ( 5 );
	char* material = NULL;
	char* name = p_arguments[1];
	float* v1;
	float* v2;
	float* v3;
	LC_READARG ( material, 0, "%p" );
	LC_READARG ( v1, 2, "%p" );
	LC_READARG ( v2, 3, "%p" );
	LC_READARG ( v3, 4, "%p" );
	_UseFloat3 ( material, name, v1, v2, v3 );
	LC_RETURN_VOID;
}

LC_ENTRY ( UseFloat4 ) 
{
	LC_ARG_COUNT ( 6 );
	char* material = NULL;
	char* name = p_arguments[1];
	float* v1;
	float* v2;
	float* v3;
	float* v4;
	LC_READARG ( material, 0, "%p" );
	LC_READARG ( v1, 2, "%p" );
	LC_READARG ( v2, 3, "%p" );
	LC_READARG ( v3, 4, "%p" );
	LC_READARG ( v4, 5, "%p" );
	_UseFloat4 ( material, name, v1, v2, v3, v4 );
	LC_RETURN_VOID;
}

LC_ENTRY ( SetInteger ) 
{
	LC_ARG_COUNT ( 3 );
	char* material = NULL;
	char* name = p_arguments[1];
	int v1;
	LC_READARG ( material, 0, "%p" );
	LC_READARG ( v1, 2, "%d" );
	_SetInteger ( material, name, v1 );
	LC_RETURN_VOID;
}

LC_ENTRY ( SetInteger2 ) 
{
	LC_ARG_COUNT ( 4 );
	char* material = NULL;
	char* name = p_arguments[1];
	int v1;
	int v2;
	LC_READARG ( material, 0, "%p" );
	LC_READARG ( v1, 2, "%d" );
	LC_READARG ( v2, 3, "%d" );
	_SetInteger2 ( material, name, v1, v2 );
	LC_RETURN_VOID;
}

LC_ENTRY ( SetInteger3 ) 
{
	LC_ARG_COUNT ( 5 );
	char* material = NULL;
	char* name = p_arguments[1];
	int v1;
	int v2;
	int v3;
	LC_READARG ( material, 0, "%p" );
	LC_READARG ( v1, 2, "%d" );
	LC_READARG ( v2, 3, "%d" );
	LC_READARG ( v3, 4, "%d" );
	_SetInteger3 ( material, name, v1, v2, v3);
	LC_RETURN_VOID;
}

LC_ENTRY ( SetInteger4 ) 
{
	LC_ARG_COUNT ( 6 );
	char* material = NULL;
	char* name = p_arguments[1];
	int v1;
	int v2;
	int v3;
	int v4;
	LC_READARG ( material, 0, "%p" );
	LC_READARG ( v1, 2, "%d" );
	LC_READARG ( v2, 3, "%d" );
	LC_READARG ( v3, 4, "%d" );
	LC_READARG ( v4, 5, "%d" );
	_SetInteger4 ( material, name, v1, v2, v3, v4 );
	LC_RETURN_VOID;
}

LC_ENTRY ( UseInteger ) 
{
	LC_ARG_COUNT ( 3 );
	char* material = NULL;
	char* name = p_arguments[1];
	int* v1;
	LC_READARG ( material, 0, "%p" );
	LC_READARG ( v1, 2, "%p" );
	_UseInteger ( material, name, v1 );
	LC_RETURN_VOID;
}

LC_ENTRY ( UseInteger2 ) 
{
	LC_ARG_COUNT ( 4 );
	char* material = NULL;
	char* name = p_arguments[1];
	int* v1;
	int* v2;
	LC_READARG ( material, 0, "%p" );
	LC_READARG ( v1, 2, "%p" );
	LC_READARG ( v2, 3, "%p" );
	_UseInteger2 ( material, name, v1, v2 );
	LC_RETURN_VOID;
}

LC_ENTRY ( UseInteger3 ) 
{
	LC_ARG_COUNT ( 5 );
	char* material = NULL;
	char* name = p_arguments[1];
	int* v1;
	int* v2;
	int* v3;
	LC_READARG ( material, 0, "%p" );
	LC_READARG ( v1, 2, "%p" );
	LC_READARG ( v2, 3, "%p" );
	LC_READARG ( v3, 4, "%p" );
	_UseInteger3 ( material, name, v1, v2, v3 );
	LC_RETURN_VOID;
}

LC_ENTRY ( UseInteger4 ) 
{
	LC_ARG_COUNT ( 6 );
	char* material = NULL;
	char* name = p_arguments[1];
	int* v1;
	int* v2;
	int* v3;
	int* v4;
	LC_READARG ( material, 0, "%p" );
	LC_READARG ( v1, 2, "%p" );
	LC_READARG ( v2, 3, "%p" );
	LC_READARG ( v3, 4, "%p" );
	LC_READARG ( v4, 5, "%p" );
	_UseInteger4 ( material, name, v1, v2, v3, v4 );
	LC_RETURN_VOID;
}

LC_ENTRY ( UseSurface ) 
{
	LC_ARG_COUNT ( 4 );
	char* material = NULL;
	char* name = NULL;
	char* surf = NULL;
	int vbo;
	LC_READARG ( material, 0, "%p" );
	LC_READARG ( name, 1, "%p" );
	LC_READARG ( surf, 2, "%p" );
	LC_READARG ( vbo, 3, "%d" );
	_UseSurface ( material, name, surf, vbo );
	LC_RETURN_VOID;
}

LC_ENTRY ( UseMatrix ) 
{
	LC_ARG_COUNT ( 3 );
	char* material = NULL;
	char* name = p_arguments[1];
	int mode;
	LC_READARG ( material, 0, "%p" );
	LC_READARG ( name, 1, "%p" );
	LC_READARG ( mode, 2, "%d" );
	_UseMatrix ( material, name, mode );
	LC_RETURN_VOID;
}

LC_ENTRY ( LoadMaterial ) 
{
	LC_ARG_COUNT ( 6 );
	char* filename = p_arguments[0];
	int flags;
	int frame_width;
	int frame_height;
	int first_frame;
	int frame_count;
	LC_READARG ( flags, 1, "%d" );
	LC_READARG ( frame_width, 2, "%d" );
	LC_READARG ( frame_height, 3, "%d" );
	LC_READARG ( first_frame, 4, "%d" );
	LC_READARG ( frame_count, 5, "%d" );
	char* result = NULL;
	result = _LoadMaterial ( filename, flags, frame_width, frame_height, first_frame, frame_count);
	LC_RETURN_POINTER;
}

LC_ENTRY ( ShaderMaterial ) 
{
	LC_ARG_COUNT ( 4 );
	char* material = NULL;
	char* tex = NULL;
	char* name = p_arguments[2];
	int index;
	LC_READARG ( material, 0, "%p" );
	LC_READARG ( tex, 1, "%p" );
	LC_READARG ( index, 3, "%d" );
	_ShaderMaterial ( material, tex, name, index);
	LC_RETURN_VOID;
}

LC_ENTRY ( CreateOcTree ) 
{
	LC_ARG_COUNT ( 3 );
	float w;
	float h;
	float d;
	char* parent_ent = NULL;
	LC_READARG ( w, 0, "%f" );
	LC_READARG ( h, 1, "%f" );
	LC_READARG ( d, 2, "%f" );
	if (p_argument_count >= 4){ LC_READARG ( parent_ent, 3, "%p" );}
	char* result = NULL;
	result = _CreateOcTree ( w, h, d, parent_ent);
	LC_RETURN_POINTER;
}

LC_ENTRY ( AddToOctree ) 
{
	LC_ARG_COUNT ( 6 );
	char* octree = NULL;
	char* mesh = NULL;
	int level;
	float X;
	float Y;
	float Z;
	float Near = 0.0;
	float Far = 1000.0;
	LC_READARG ( octree, 0, "%p" );
	LC_READARG ( mesh, 1, "%p" );
	LC_READARG ( level, 2, "%d" );
	LC_READARG ( X, 3, "%f" );
	LC_READARG ( Y, 4, "%f" );
	LC_READARG ( Z, 5, "%f" );
	if (p_argument_count >= 7){	LC_READARG ( Near, 6, "%f" );}
	if (p_argument_count >= 8){	LC_READARG ( Far, 7, "%f" );}
	_AddToOctree ( octree, mesh, level, X, Y, Z, Near, Far );
	LC_RETURN_VOID;
}

LC_ENTRY ( Swap )
{
	// win32 only?...
	SwapBuffers( hDC );
	LC_RETURN_VOID;
}

EXTERNAL_BEGIN_DECLARATIONS("extopenb3d")

EXTERNAL_DECLARE_COMMAND ( "Swap", Swap )
EXTERNAL_DECLARE_COMMAND ( "BufferToTex", BufferToTex )
EXTERNAL_DECLARE_COMMAND ( "BackBufferToTex", BackBufferToTex )
EXTERNAL_DECLARE_COMMAND ( "TexToBuffer", TexToBuffer )
EXTERNAL_DECLARE_COMMAND ( "MeshCullRadius", MeshCullRadius )
EXTERNAL_DECLARE_FUNCTION ( "AddAnimSeq", AddAnimSeq )
EXTERNAL_DECLARE_COMMAND ( "AddMesh", AddMesh )
EXTERNAL_DECLARE_FUNCTION ( "AddTriangle", AddTriangle )
EXTERNAL_DECLARE_FUNCTION ( "AddVertex", AddVertex )
EXTERNAL_DECLARE_COMMAND ( "AmbientLight", AmbientLight )
EXTERNAL_DECLARE_COMMAND ( "AntiAlias", AntiAlias )
EXTERNAL_DECLARE_COMMAND ( "Animate", Animate )
EXTERNAL_DECLARE_FUNCTION ( "Animating", Animating )
EXTERNAL_DECLARE_FUNCTION ( "AnimLength", AnimLength )
EXTERNAL_DECLARE_FUNCTION ( "AnimSeq", AnimSeq )
EXTERNAL_DECLARE_FUNCTION ( "AnimTime", AnimTime )
EXTERNAL_DECLARE_COMMAND ( "BrushAlpha", BrushAlpha )
EXTERNAL_DECLARE_COMMAND ( "BrushBlend", BrushBlend )
EXTERNAL_DECLARE_COMMAND ( "BrushColor", BrushColor )
EXTERNAL_DECLARE_COMMAND ( "BrushFX", BrushFX )
EXTERNAL_DECLARE_COMMAND ( "BrushShininess", BrushShininess )
EXTERNAL_DECLARE_COMMAND ( "BrushTexture", BrushTexture )
EXTERNAL_DECLARE_COMMAND ( "CameraClsColor", CameraClsColor )
EXTERNAL_DECLARE_COMMAND ( "CameraClsMode", CameraClsMode )
EXTERNAL_DECLARE_COMMAND ( "CameraFogColor", CameraFogColor )
EXTERNAL_DECLARE_COMMAND ( "CameraFogMode", CameraFogMode )
EXTERNAL_DECLARE_COMMAND ( "CameraFogRange", CameraFogRange )
EXTERNAL_DECLARE_FUNCTION ( "CameraPick", CameraPick )
EXTERNAL_DECLARE_COMMAND ( "CameraProject", CameraProject )
EXTERNAL_DECLARE_COMMAND ( "CameraProjMode", CameraProjMode )
EXTERNAL_DECLARE_COMMAND ( "CameraRange", CameraRange )
EXTERNAL_DECLARE_COMMAND ( "CameraViewport", CameraViewport )
EXTERNAL_DECLARE_COMMAND ( "CameraZoom", CameraZoom )
EXTERNAL_DECLARE_COMMAND ( "ClearCollisions", ClearCollisions )
EXTERNAL_DECLARE_COMMAND ( "ClearSurface", ClearSurface )
EXTERNAL_DECLARE_COMMAND ( "ClearTextureFilters", ClearTextureFilters )
EXTERNAL_DECLARE_COMMAND ( "ClearWorld", ClearWorld )
EXTERNAL_DECLARE_FUNCTION ( "CollisionEntity", CollisionEntity )
EXTERNAL_DECLARE_COMMAND ( "Collisions", Collisions )
EXTERNAL_DECLARE_FUNCTION ( "CollisionNX", CollisionNX )
EXTERNAL_DECLARE_FUNCTION ( "CollisionNY", CollisionNY )
EXTERNAL_DECLARE_FUNCTION ( "CollisionNZ", CollisionNZ )
EXTERNAL_DECLARE_FUNCTION ( "CollisionSurface", CollisionSurface )
EXTERNAL_DECLARE_FUNCTION ( "CollisionTime", CollisionTime )
EXTERNAL_DECLARE_FUNCTION ( "CollisionTriangle", CollisionTriangle )
EXTERNAL_DECLARE_FUNCTION ( "CollisionX", CollisionX )
EXTERNAL_DECLARE_FUNCTION ( "CollisionY", CollisionY )
EXTERNAL_DECLARE_FUNCTION ( "CollisionZ", CollisionZ )
EXTERNAL_DECLARE_FUNCTION ( "CountChildren", CountChildren )
EXTERNAL_DECLARE_FUNCTION ( "CountCollisions", CountCollisions )
EXTERNAL_DECLARE_FUNCTION ( "CopyEntity", CopyEntity )
EXTERNAL_DECLARE_FUNCTION ( "CopyMesh", CopyMesh )
EXTERNAL_DECLARE_FUNCTION ( "CountSurfaces", CountSurfaces )
EXTERNAL_DECLARE_FUNCTION ( "CountTriangles", CountTriangles )
EXTERNAL_DECLARE_FUNCTION ( "CountVertices", CountVertices )
EXTERNAL_DECLARE_FUNCTION ( "CreateBrush", CreateBrush )
EXTERNAL_DECLARE_FUNCTION ( "CreateCamera", CreateCamera )
EXTERNAL_DECLARE_FUNCTION ( "CreateCone", CreateCone )
EXTERNAL_DECLARE_FUNCTION ( "CreateCylinder", CreateCylinder )
EXTERNAL_DECLARE_FUNCTION ( "CreateCube", CreateCube )
EXTERNAL_DECLARE_FUNCTION ( "CreateMesh", CreateMesh )
EXTERNAL_DECLARE_FUNCTION ( "CreateLight", CreateLight )
EXTERNAL_DECLARE_FUNCTION ( "CreatePivot", CreatePivot )
EXTERNAL_DECLARE_FUNCTION ( "CreatePlane", CreatePlane )
EXTERNAL_DECLARE_FUNCTION ( "CreateShadow", CreateShadow )
EXTERNAL_DECLARE_FUNCTION ( "CreateSphere", CreateSphere )
EXTERNAL_DECLARE_FUNCTION ( "CreateSprite", CreateSprite )
EXTERNAL_DECLARE_FUNCTION ( "CreateSurface", CreateSurface )
EXTERNAL_DECLARE_FUNCTION ( "CreateStencil", CreateStencil )
EXTERNAL_DECLARE_FUNCTION ( "CreateTerrain", CreateTerrain )
EXTERNAL_DECLARE_FUNCTION ( "CreateTexture", CreateTexture )
EXTERNAL_DECLARE_FUNCTION ( "CreateVoxelSprite", CreateVoxelSprite )
EXTERNAL_DECLARE_FUNCTION ( "DeltaPitch", DeltaPitch )
EXTERNAL_DECLARE_FUNCTION ( "DeltaYaw", DeltaYaw )
EXTERNAL_DECLARE_COMMAND ( "EntityAlpha", EntityAlpha )
EXTERNAL_DECLARE_COMMAND ( "EntityAutoFade", EntityAutoFade )
EXTERNAL_DECLARE_COMMAND ( "EntityBlend", EntityBlend )
EXTERNAL_DECLARE_COMMAND ( "EntityBox", EntityBox )
EXTERNAL_DECLARE_FUNCTION ( "EntityCollided", EntityCollided )
EXTERNAL_DECLARE_COMMAND ( "EntityColor", EntityColor )
EXTERNAL_DECLARE_FUNCTION ( "EntityDistance", EntityDistance )
EXTERNAL_DECLARE_COMMAND ( "EntityFX", EntityFX )
EXTERNAL_DECLARE_FUNCTION ( "EntityInView", EntityInView )
EXTERNAL_DECLARE_COMMAND ( "EntityOrder", EntityOrder )
EXTERNAL_DECLARE_COMMAND ( "EntityParent", EntityParent )
EXTERNAL_DECLARE_FUNCTION ( "EntityPick", EntityPick )
EXTERNAL_DECLARE_COMMAND ( "EntityPickMode", EntityPickMode )
EXTERNAL_DECLARE_FUNCTION ( "EntityPitch", EntityPitch )
EXTERNAL_DECLARE_COMMAND ( "EntityRadius", EntityRadius )
EXTERNAL_DECLARE_FUNCTION ( "EntityRoll", EntityRoll )
EXTERNAL_DECLARE_COMMAND ( "EntityShininess", EntityShininess )
EXTERNAL_DECLARE_COMMAND ( "EntityTexture", EntityTexture )
EXTERNAL_DECLARE_COMMAND ( "EntityType", EntityType )
EXTERNAL_DECLARE_FUNCTION ( "EntityVisible", EntityVisible )
EXTERNAL_DECLARE_FUNCTION ( "EntityX", EntityX )
EXTERNAL_DECLARE_FUNCTION ( "EntityY", EntityY )
EXTERNAL_DECLARE_FUNCTION ( "EntityYaw", EntityYaw )
EXTERNAL_DECLARE_FUNCTION ( "EntityZ", EntityZ )
EXTERNAL_DECLARE_FUNCTION ( "ExtractAnimSeq", ExtractAnimSeq )
EXTERNAL_DECLARE_FUNCTION ( "FindChild", FindChild )
EXTERNAL_DECLARE_FUNCTION ( "FindSurface", FindSurface )
EXTERNAL_DECLARE_COMMAND ( "FitMesh", FitMesh )
EXTERNAL_DECLARE_COMMAND ( "FlipMesh", FlipMesh )
EXTERNAL_DECLARE_COMMAND ( "FreeBrush", FreeBrush )
EXTERNAL_DECLARE_COMMAND ( "FreeEntity", FreeEntity )
EXTERNAL_DECLARE_COMMAND ( "FreeShadow", FreeShadow )
EXTERNAL_DECLARE_COMMAND ( "FreeTexture", FreeTexture )
EXTERNAL_DECLARE_FUNCTION ( "GetBrushTexture", GetBrushTexture )
EXTERNAL_DECLARE_FUNCTION ( "GetChild", GetChild )
EXTERNAL_DECLARE_FUNCTION ( "GetEntityBrush", GetEntityBrush )
EXTERNAL_DECLARE_FUNCTION ( "GetEntityType", GetEntityType )
EXTERNAL_DECLARE_FUNCTION ( "GetMatElement", GetMatElement )
EXTERNAL_DECLARE_FUNCTION ( "GetParentEntity", GetParentEntity )
EXTERNAL_DECLARE_FUNCTION ( "GetSurface", GetSurface )
EXTERNAL_DECLARE_FUNCTION ( "GetSurfaceBrush", GetSurfaceBrush )
EXTERNAL_DECLARE_COMMAND ( "Graphics3D", Graphics3D )
EXTERNAL_DECLARE_COMMAND ( "HandleSprite", HandleSprite )
EXTERNAL_DECLARE_COMMAND ( "HideEntity", HideEntity )
EXTERNAL_DECLARE_COMMAND ( "LightColor", LightColor )
EXTERNAL_DECLARE_COMMAND ( "LightConeAngles", LightConeAngles )
EXTERNAL_DECLARE_COMMAND ( "LightRange", LightRange )
EXTERNAL_DECLARE_FUNCTION ( "LinePick", LinePick )
EXTERNAL_DECLARE_FUNCTION ( "LoadAnimMesh", LoadAnimMesh )
EXTERNAL_DECLARE_FUNCTION ( "LoadAnimTexture", LoadAnimTexture )
EXTERNAL_DECLARE_FUNCTION ( "LoadBrush", LoadBrush )
EXTERNAL_DECLARE_FUNCTION ( "LoadMesh", LoadMesh )
EXTERNAL_DECLARE_FUNCTION ( "LoadTerrain", LoadTerrain )
EXTERNAL_DECLARE_FUNCTION ( "LoadTexture", LoadTexture )
EXTERNAL_DECLARE_FUNCTION ( "LoadSprite", LoadSprite )
EXTERNAL_DECLARE_FUNCTION ( "MeshCSG", MeshCSG )
EXTERNAL_DECLARE_FUNCTION ( "MeshDepth", MeshDepth )
EXTERNAL_DECLARE_FUNCTION ( "MeshesIntersect", MeshesIntersect )
EXTERNAL_DECLARE_FUNCTION ( "MeshHeight", MeshHeight )
EXTERNAL_DECLARE_FUNCTION ( "MeshWidth", MeshWidth )
EXTERNAL_DECLARE_COMMAND ( "ModifyTerrain", ModifyTerrain )
EXTERNAL_DECLARE_COMMAND ( "MoveEntity", MoveEntity )
EXTERNAL_DECLARE_COMMAND ( "NameEntity", NameEntity )
EXTERNAL_DECLARE_COMMAND ( "PaintEntity", PaintEntity )
EXTERNAL_DECLARE_COMMAND ( "PaintMesh", PaintMesh )
EXTERNAL_DECLARE_COMMAND ( "PaintSurface", PaintSurface )
EXTERNAL_DECLARE_FUNCTION ( "PickedEntity", PickedEntity )
EXTERNAL_DECLARE_FUNCTION ( "PickedNX", PickedNX )
EXTERNAL_DECLARE_FUNCTION ( "PickedNY", PickedNY )
EXTERNAL_DECLARE_FUNCTION ( "PickedNZ", PickedNZ )
EXTERNAL_DECLARE_FUNCTION ( "PickedSurface", PickedSurface )
EXTERNAL_DECLARE_FUNCTION ( "PickedTime", PickedTime )
EXTERNAL_DECLARE_FUNCTION ( "PickedTriangle", PickedTriangle )
EXTERNAL_DECLARE_FUNCTION ( "PickedX", PickedX )
EXTERNAL_DECLARE_FUNCTION ( "PickedY", PickedY )
EXTERNAL_DECLARE_FUNCTION ( "PickedZ", PickedZ )
EXTERNAL_DECLARE_COMMAND ( "PointEntity", PointEntity )
EXTERNAL_DECLARE_COMMAND ( "PositionEntity", PositionEntity )
EXTERNAL_DECLARE_COMMAND ( "PositionMesh", PositionMesh )
EXTERNAL_DECLARE_COMMAND ( "PositionTexture", PositionTexture )
EXTERNAL_DECLARE_FUNCTION ( "ProjectedX", ProjectedX )
EXTERNAL_DECLARE_FUNCTION ( "ProjectedY", ProjectedY )
EXTERNAL_DECLARE_FUNCTION ( "ProjectedZ", ProjectedZ )
EXTERNAL_DECLARE_COMMAND ( "RenderWorld", RenderWorld )
EXTERNAL_DECLARE_FUNCTION ( "RepeatMesh", RepeatMesh )
EXTERNAL_DECLARE_COMMAND ( "ResetEntity", ResetEntity )
EXTERNAL_DECLARE_COMMAND ( "RotateEntity", RotateEntity )
EXTERNAL_DECLARE_COMMAND ( "RotateMesh", RotateMesh )
EXTERNAL_DECLARE_COMMAND ( "RotateSprite", RotateSprite )
EXTERNAL_DECLARE_COMMAND ( "RotateTexture", RotateTexture )
EXTERNAL_DECLARE_COMMAND ( "ScaleEntity", ScaleEntity )
EXTERNAL_DECLARE_COMMAND ( "ScaleMesh", ScaleMesh )
EXTERNAL_DECLARE_COMMAND ( "ScaleSprite", ScaleSprite )
EXTERNAL_DECLARE_COMMAND ( "ScaleTexture", ScaleTexture )
EXTERNAL_DECLARE_COMMAND ( "SetAnimTime", SetAnimTime )
EXTERNAL_DECLARE_COMMAND ( "SetCubeFace", SetCubeFace )
EXTERNAL_DECLARE_COMMAND ( "SetCubeMode", SetCubeMode )
EXTERNAL_DECLARE_COMMAND ( "ShowEntity", ShowEntity )
EXTERNAL_DECLARE_COMMAND ( "SpriteViewMode", SpriteViewMode )
EXTERNAL_DECLARE_COMMAND ( "StencilAlpha", StencilAlpha )
EXTERNAL_DECLARE_COMMAND ( "StencilClsColor", StencilClsColor )
EXTERNAL_DECLARE_COMMAND ( "StencilMesh", StencilMesh )
EXTERNAL_DECLARE_COMMAND ( "StencilMode", StencilMode )
EXTERNAL_DECLARE_FUNCTION ( "TerrainHeight", TerrainHeight )
EXTERNAL_DECLARE_FUNCTION ( "TerrainX", TerrainX )
EXTERNAL_DECLARE_FUNCTION ( "TerrainY", TerrainY )
EXTERNAL_DECLARE_FUNCTION ( "TerrainZ", TerrainZ )
EXTERNAL_DECLARE_COMMAND ( "TextureBlend", TextureBlend )
EXTERNAL_DECLARE_COMMAND ( "TextureCoords", TextureCoords )
EXTERNAL_DECLARE_FUNCTION ( "TextureHeight", TextureHeight )
EXTERNAL_DECLARE_COMMAND ( "TextureFilter", TextureFilter )
EXTERNAL_DECLARE_FUNCTION ( "TextureWidth", TextureWidth )
EXTERNAL_DECLARE_FUNCTION ( "TFormedX", TFormedX )
EXTERNAL_DECLARE_FUNCTION ( "TFormedY", TFormedY )
EXTERNAL_DECLARE_FUNCTION ( "TFormedZ", TFormedZ )
EXTERNAL_DECLARE_COMMAND ( "TFormNormal", TFormNormal )
EXTERNAL_DECLARE_COMMAND ( "TFormPoint", TFormPoint )
EXTERNAL_DECLARE_COMMAND ( "TFormVector", TFormVector )
EXTERNAL_DECLARE_COMMAND ( "TranslateEntity", TranslateEntity )
EXTERNAL_DECLARE_FUNCTION ( "TriangleVertex", TriangleVertex )
EXTERNAL_DECLARE_COMMAND ( "TurnEntity", TurnEntity )
EXTERNAL_DECLARE_COMMAND ( "UpdateNormals", UpdateNormals )
EXTERNAL_DECLARE_COMMAND ( "UpdateTexCoords", UpdateTexCoords )
EXTERNAL_DECLARE_COMMAND ( "UpdateWorld", UpdateWorld )
EXTERNAL_DECLARE_COMMAND ( "UseStencil", UseStencil )
EXTERNAL_DECLARE_FUNCTION ( "VectorPitch", VectorPitch )
EXTERNAL_DECLARE_FUNCTION ( "VectorYaw", VectorYaw )
EXTERNAL_DECLARE_FUNCTION ( "VertexAlpha", VertexAlpha )
EXTERNAL_DECLARE_FUNCTION ( "VertexBlue", VertexBlue )
EXTERNAL_DECLARE_COMMAND ( "VertexColor", VertexColor )
EXTERNAL_DECLARE_COMMAND ( "VertexCoords", VertexCoords )
EXTERNAL_DECLARE_FUNCTION ( "VertexGreen", VertexGreen )
EXTERNAL_DECLARE_COMMAND ( "VertexNormal", VertexNormal )
EXTERNAL_DECLARE_FUNCTION ( "VertexNX", VertexNX )
EXTERNAL_DECLARE_FUNCTION ( "VertexNY", VertexNY )
EXTERNAL_DECLARE_FUNCTION ( "VertexNZ", VertexNZ )
EXTERNAL_DECLARE_FUNCTION ( "VertexRed", VertexRed )
EXTERNAL_DECLARE_COMMAND ( "VertexTexCoords", VertexTexCoords )
EXTERNAL_DECLARE_FUNCTION ( "VertexU", VertexU )
EXTERNAL_DECLARE_FUNCTION ( "VertexV", VertexV )
EXTERNAL_DECLARE_FUNCTION ( "VertexW", VertexW )
EXTERNAL_DECLARE_FUNCTION ( "VertexX", VertexX )
EXTERNAL_DECLARE_FUNCTION ( "VertexY", VertexY )
EXTERNAL_DECLARE_FUNCTION ( "VertexZ", VertexZ )
EXTERNAL_DECLARE_COMMAND ( "VoxelSpriteMaterial", VoxelSpriteMaterial )
EXTERNAL_DECLARE_COMMAND ( "Wireframe", Wireframe )
EXTERNAL_DECLARE_FUNCTION ( "EntityScaleX", EntityScaleX )
EXTERNAL_DECLARE_FUNCTION ( "EntityScaleY", EntityScaleY )
EXTERNAL_DECLARE_FUNCTION ( "EntityScaleZ", EntityScaleZ )
EXTERNAL_DECLARE_FUNCTION ( "LoadShader", LoadShader )
EXTERNAL_DECLARE_FUNCTION ( "CreateShader", CreateShader )
EXTERNAL_DECLARE_COMMAND ( "ShadeSurface", ShadeSurface )
EXTERNAL_DECLARE_COMMAND ( "ShadeMesh", ShadeMesh )
EXTERNAL_DECLARE_COMMAND ( "ShadeEntity", ShadeEntity )
EXTERNAL_DECLARE_COMMAND ( "ShaderTexture", ShaderTexture )
EXTERNAL_DECLARE_COMMAND ( "SetFloat", SetFloat )
EXTERNAL_DECLARE_COMMAND ( "SetFloat2", SetFloat2 )
EXTERNAL_DECLARE_COMMAND ( "SetFloat3", SetFloat3 )
EXTERNAL_DECLARE_COMMAND ( "SetFloat4", SetFloat4 )
EXTERNAL_DECLARE_COMMAND ( "UseFloat", UseFloat )
EXTERNAL_DECLARE_COMMAND ( "UseFloat2", UseFloat2 )
EXTERNAL_DECLARE_COMMAND ( "UseFloat3", UseFloat3 )
EXTERNAL_DECLARE_COMMAND ( "UseFloat4", UseFloat4 )
EXTERNAL_DECLARE_COMMAND ( "SetInteger", SetInteger )
EXTERNAL_DECLARE_COMMAND ( "SetInteger2", SetInteger2 )
EXTERNAL_DECLARE_COMMAND ( "SetInteger3", SetInteger3 )
EXTERNAL_DECLARE_COMMAND ( "SetInteger4", SetInteger4 )
EXTERNAL_DECLARE_COMMAND ( "UseInteger", UseInteger )
EXTERNAL_DECLARE_COMMAND ( "UseInteger2", UseInteger2 )
EXTERNAL_DECLARE_COMMAND ( "UseInteger3", UseInteger3 )
EXTERNAL_DECLARE_COMMAND ( "UseInteger4", UseInteger4 )
EXTERNAL_DECLARE_COMMAND ( "UseSurface", UseSurface )
EXTERNAL_DECLARE_COMMAND ( "UseMatrix", UseMatrix )
EXTERNAL_DECLARE_FUNCTION ( "LoadMaterial", LoadMaterial )
EXTERNAL_DECLARE_COMMAND ( "ShaderMaterial", ShaderMaterial )
EXTERNAL_DECLARE_FUNCTION ( "CreateOcTree", CreateOcTree )
EXTERNAL_DECLARE_COMMAND ( "AddToOctree", AddToOctree )

EXTERNAL_END_DECLARATIONS